<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.0
	 */

	/**
	 *	eBag input box sizes loader
	 *	Load once into mem to all users
	 */

	/**
	 *	Usage:	$BOX=new BOX($apc, $lang, $reload);
	 *		echo $BOX->size('key');
	 */

	class BOX	{
	
		var $SIZE = array();

		/**
		 * Reads conf file into array & store 
		 */

		function __construct($apc=FALSE, $lang='eng', $reload=FALSE)	{
				
			if (! function_exists('apc_fetch')) $apc = FALSE;

			if ($apc)	{
			
				if ((! $reload) && apc_exists('eBagBoxes'))	{
			
					$this->SIZE = apc_fetch('eBagBoxes');
					
					return;
				}
			}

			$this->SIZE = parse_ini_file(BASEDIR."lang/$lang/boxsizes.$lang");

			if ((! $this->SIZE) or (! count($this->SIZE))) exit("Fatal error: ebag configuration file boxsizes.$lang not found ! Please contact your system administrator !");

			if ($apc) apc_store('eBagBoxes', (array)$this->SIZE, 0);
		}

		/**
		 * Returns size by key
		 * Default 65 if the size is not defined
		 */

		public function size($key)	{

			$val=65;
			
			if (isset($this->SIZE[$key])) $val = $this->SIZE[$key];

			return $val;
		}
	}


?>
