<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag file download class
	 */

	class DOWNLOAD	{
	
		function __construct($FILE_ID, $KBs=FALSE)	{
		
			if (! $KBs) $KBs = 192;

			list($directoryID, $fileID) = explode('_', $FILE_ID);

			if ((! $directoryID) or (! $fileID)) $this->header404();

			$file_with_path = $_SESSION['uploaddir']."/upl$directoryID/upl$fileID.upl";

			global $__SQL;

			# read filename, size from base

			$__SQL->query("	SELECT `filename`, `filesize`, `mimetype`
					FROM ebag.uploads
					WHERE `personID`='$fileID' LIMIT 1"	);

			if (! $__SQL->num_rows()) $this->header404();

			$RESULT	= $__SQL->RESULT->fetch_assoc();

			extract($RESULT); unset($RESULT);
			
			set_time_limit(0);
			
			if (! $fp = @fopen(realpath($file_with_path), 'rb')) $this->header404();
			
			$now = @gmdate("D, d M Y H:i:s").' GMT';

			header('Content-Description: File Transfer');
			header("Date: $now");
			header('Expires: Sun, 10 Jan 2010 12:00:00 GMT');
			header("Last-Modified: $now");
			
			header('Pragma: no-cache');
			header('Cache-Control: no-cache, no-store, must-revalidate');
			
			header("Content-Type: $mimetype");
			header("Content-Disposition: attachment; filename=\"$filename\"; filename*=utf-8''".rawurlencode($filename));
			header('Content-Transfer-Encoding: bytes');
			header("Content-Length: $filesize"); 

			ob_end_clean();
			
			flush();
			
			$start = microtime(true);
			
			$i = 0;
			
			$max = (integer)(ceil($KBs/8));
			
			while (! feof( $fp))	{
			
			      echo fread($fp, 8192);

			      flush();

			      $i++;
			      
			      if ($i == $max)	{
			      
				      $end = microtime(true);
				      
				      $diff = (1-$end+$start)*1000000;

				      if ($diff > 0) usleep($diff);

				      $i = 0;
				      
				      $start = microtime(true);
			      }
			}
			
			fclose($fp);
		}
		
		private function header404()	{
		
			header("HTTP/1.0 404 Not Found"); 
			
			exit;
		}
	}


?>
