<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 5.0.0
	 */

	/**
	 * eBag creates table for order to stock from orderID
	 */

	include('../functions/mb_wrap.php');

	class STOCKORDER2SELL	{

		function __construct()	{

			global $__SQL, $__LANG, $__BOX;

			$this->SQL		=	&$__SQL;

			$this->LANG		=	&$__LANG;
			
			$this->BOX		=	&$__BOX;

			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';

			$this->TABLE		=	'';
		}
		
		public function createbyorder($orderID)	{
		
			$table_is_empty = TRUE;

			# create temporary table with sums

			$this->SQL->query("	DROP TEMPORARY TABLE IF EXISTS $this->BASE.temp_order_table ");

			$this->SQL->query("	CREATE TEMPORARY TABLE $this->BASE.temp_order_table
						SELECT `code`, `articalname`, SUM(`quantity`) AS `quantity`, `unit` FROM $this->BASE.orders_data
						WHERE `orderID`='$orderID' AND `deleted` IS NOT NULL GROUP BY `code`	");

			# note: origin 1 is product

			$this->SQL->query("	SELECT temp_order_table.code, temp_order_table.articalname, temp_order_table.unit, temp_order_table.quantity,
						finished_goods_stock.quantity AS stock_quantity, 
						(finished_goods_stock.quantity_ordered-temp_order_table.quantity) AS ordered_from_stock, 
				 		finished_goods_stock.quantity_ordered_to_stock AS ordered_to_stock, 
						finished_goods_stock.quantity_on_opened_order_to_stock AS on_opened_order_to_stock,
						finished_goods_stock.quantity_as_part AS requested_as_part
		  				FROM $this->BASE.temp_order_table INNER JOIN $this->STOCKBASE.finished_goods_stock
						ON temp_order_table.code=finished_goods_stock.code
		  				WHERE finished_goods_stock.origin!='1'	
		  				AND finished_goods_stock.deleted IS NOT NULL");

			if (! $NUMROWS = $this->SQL->num_rows())	{

				$this->SQL->query("DROP TEMPORARY TABLE IF EXISTS $this->BASE.temp_order_table ");

				return FALSE;
			}
			
			$this->SQL->IT1_RESULT = $this->SQL->RESULT;

			# create table header

			$COLUMNS	=	array(	$this->LANG->get('code'), 
							$this->LANG->get('articalname'), 
							$this->LANG->get('unit'), 
							$this->LANG->get('ordered_quantity'),
							$this->LANG->get('stock_quantity'), 
							$this->LANG->get('ordered_from_stock'), 
							$this->LANG->get('quantity_ordered_to_stock'), 
							$this->LANG->get('on_opened_order_to_stock'), 
							$this->LANG->get('quantity_as_part'), 
							$this->LANG->get('to_order')	);

			$this->TABLE	=	"<div class=\"border\">\n<div class=\"padding-list\">\n<table id=\"data\" class=\"list\"><tr class=\"list-column-names\">\n";

			foreach ($COLUMNS as $NAME)	$this->TABLE .= '<td>'.mb_wrap($NAME, 6, '<br>').'</td>'."\n";

			$this->TABLE	.=	'</tr>'."\n";

			# create table body

			$CLASS		=	'list-dark';
			$INC		=	0;

			while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

				$difference = 0 - ($RESULT['stock_quantity'] + $RESULT['ordered_to_stock'] + $RESULT['on_opened_order_to_stock'] - $RESULT['ordered_from_stock'] - $RESULT['quantity'] - $RESULT['requested_as_part']);
				
				if ($difference <= 0) continue;
				
				$table_is_empty = FALSE;

				if ($CLASS=='list-dark') {$CLASS = 'list-light';} else {$CLASS = 'list-dark';}

				$this->TABLE .=	"<tr class=\"$CLASS\" onmouseover=\"Javascript: mark(this);\" onmouseout=\"Javascript: unmark(this);\">\n";
				
				foreach ($RESULT as $COLUMN=>$VALUE)	{
				
					if (($COLUMN != 'code') && ($COLUMN != 'articalname') && ($COLUMN != 'unit')) $VALUE = number_format($VALUE , 2, '.', '');

					$this->TABLE 	.=	'<td><input name="'.$COLUMN.'[]" class="list-input" style="width: '.$this->BOX->size($COLUMN).'px;" readonly value="'.$VALUE.'" onkeypress="return nextfield(this, event, \'to_order_'.$INC.'\');"></td>'."\n";
				}		

				# additional input for quantity

				$FIELDID	=	"to_order_$INC";

				if ($INC==$NUMROWS-1)	{

					$NEXTFIELD='return nextfield(this,event, \'submit\');';

				}	else	  {

					$INC++;

					$NEXTFIELD="return nextfield(this,event, 'to_order_$INC');";
				}

				$difference =  number_format($difference , 2, '.', '');
				
				$this->TABLE .= "<td><input id=\"$FIELDID\" name=\"order[]\" class=\"search-box\" style=\"width: ".$this->BOX->size('difference')."px;\" value=\"$difference\" onkeypress=\"$NEXTFIELD\"></td>\n";

				$this->TABLE .=	'</tr>'."\n";
			}

			$this->TABLE	.=	'</table></div></div>'."\n";

			$this->SQL->query("DROP TEMPORARY TABLE IF EXISTS $this->BASE.temp_order_table ");

			if (! $table_is_empty) return TRUE;
			
			return FALSE;
		}
	}
?>
