<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag create table with uploaded files readed from base
	 */
	 
	if (! function_exists('file_extension')) load_f('file_extension');

	class FILE	{

		function __construct($file)	{
		
			if ($this->EXTENSION = file_extension($file['filename']))	 {

				$this->FILENAME	 = mb_ereg_replace('.'.$this->EXTENSION.'$', '', $file['filename']);

			}	else	{

				$this->FILENAME  = $file['filename'];
			}

			$size	=	$file['filesize'];

			if ($size/1024/1024 < 0.01)	{

				$this->SIZE	=	number_format($size/1024, 2, '.', '');

				$this->UNIT	=	'kB';

			}	else	  {

				$this->SIZE	=	number_format($size/1024/1024, 2, '.', '');

				$this->UNIT	=	'MB';
			}

			$this->UPLOADED = $file['date_of_creation'];

			$this->LINKNAME	= $file['directoryID'].'_'.$file['personID'];
		}
	}

	class UPLOADED		{

		var $TABLE	=	'';

		function __construct($TYPE)	{

			$this->TYPE = $TYPE;

			global $__SQL, $__CONF, $__LANG;

			$this->SQL	=	&$__SQL;

			$this->FORMAT 	=	$__CONF->get('date', 'sql_format');

			$this->FILENAME_TXT	=	$__LANG->get('filename');
			$this->EXTENSION_TXT	=	$__LANG->get('extension');
			$this->SIZE_TXT		=	$__LANG->get('size');
			$this->CREATED_TXT	=	$__LANG->get('created');
			$this->NOUPLOAD_TXT	=	$__LANG->get('nothinguploaded');
			$this->DOWNLOAD_TXT	=	$__LANG->get('download');
			$this->DELETE_TXT	=	$__LANG->get('delete');
		}

		public function read()	{

			if ($this->TYPE == 'c')		{

				$owner	=	$this->SQL->n_escape(md5('company'));

			}	else	  {

				$owner	=	$this->SQL->n_escape($_SESSION['username']);
			}
			

			$this->SQL->query("	SELECT 	`personID`, `directoryID`, `filename`,  `filesize`, 
							DATE_FORMAT(`date_of_creation`, '$this->FORMAT') AS `date_of_creation`
						FROM ebag.uploads
						WHERE `type`='$this->TYPE' AND `owner`=$owner ORDER BY `filename`	");

			if ($this->SQL->num_rows())	{

				$INC = 1;

				while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

					$__FILE	= new FILE($RESULT);

					unset($RESULT);

					$this->TABLE	.= 	<<<"EOT"
								<tr>
									<td width="30">
										<img src="../images/file.png" width="23" height="23" title="" alt="" border="0">
									</td>
									<td class="filename">
										<a target="downloadframe" href="../controllers/filedownload.php?file=$__FILE->LINKNAME">
											$__FILE->FILENAME
										</a>
									</td>
									<td class="fileext">$__FILE->EXTENSION</td>
									<td class="filesize">$__FILE->SIZE</td>
									<td class="fileunit">$__FILE->UNIT</td>
									<td class="filedate">$__FILE->UPLOADED</td>
									<td class="filelink">
										<a target="downloadframe" href="../controllers/filedownload.php?file=$__FILE->LINKNAME">
											<img src="../images/download.png" width="23" height="19" title="$this->DOWNLOAD_TXT" alt="$this->DOWNLOAD_TXT" border="0">
										</a>
									</td>
									<td class="filelink">
										<a href="#" onclick="Javascript: verify('$__FILE->FILENAME.$__FILE->EXTENSION', '$INC')">
											<img src="../images/delete.png" width="12" height="12" title="$this->DELETE_TXT" alt="$this->DELETE_TXT" border="0">
											<input id="fileID_$INC" name="fileID_$INC" type="hidden" value="$__FILE->LINKNAME">
										</a>
									</td>
								</tr>
EOT;
					$INC++;

				}
			}

			if (! $this->TABLE)	{

				$this->TABLE = "<tr><td colspan=\"7\" align=\"center\">$this->NOUPLOAD_TXT</td></tr>";

				$HEADER	 =  '';

			}	else 	  {

				$HEADER		=	<<<"EOT"
							<tr class="fileheader">
								<td></td>
								<td>$this->FILENAME_TXT</td>
								<td class="fileext">$this->EXTENSION_TXT</td>
								<td class="filesize">$this->SIZE_TXT</td>
								<td></td>
								<td class="filedate">$this->CREATED_TXT</td>
								<td></td><td></td>
							</tr>
EOT;
			}

			$this->TABLE = "<table class=\"filetable\"> $HEADER $this->TABLE</table>";

		}

	}
?>
