<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag artical change
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('stock');

	pagepermission('stock', 'w');

	if (isset($_GET['id']))		{

		$ID = $_SESSION['ID'] = $_GET['id'];
		
		unset($_SESSION['_POST_ERR']);

	}	else	  {

		$ID = $_SESSION['ID'];
	}

	load_c('SQL');

	$__SQL	= new SQL();

	if ((isset($_POST['submit'])) or (isset($_POST['submitclone'])))	{


		if (isset($_POST['submit']))		{

			load_m('articalupdate');

			$__ARTICAL = new ARTICALUPDATE();

			$RESULT	= $__ARTICAL->update($ID, $_POST);
		}

		if (isset($_POST['submitclone']))	{

			load_m('articalwrite');

			$__ARTICAL = new ARTICALWRITE();

			$RESULT	= $__ARTICAL->copy($_POST);
		}

		unset($__ARTICAL, $__SQL);

		if ($RESULT !== TRUE)	{
		
			$_POST['_err_address'] = backward();

			$_SESSION['_POST_ERR']	=  	$_POST;

			# analize error type

			if (strpos($RESULT, '->') !== FALSE)	{

				list ($errtype, $point, $pointID) = explode('->', $RESULT);

				$ERROR	=	$__LANG->get($errtype, $__LANG->get($point).': '.$pointID);

			}	else	 {

				$ERROR	= $__LANG->get($RESULT);
			}

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_POST['_err_address']);
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $ERROR);
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('datawritten'));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', $_SESSION['FROM']);
		$view	->	display();
		exit;
	}

	if (post_data_verified())	{

		$ARTICALDATA = enc_quotes($_SESSION['_POST_ERR']); 
		
		unset($_SESSION['_POST_ERR']);

	}	else	 {

		load_m('articalread');

		$__ARTICAL = new ARTICALREAD();

		$ARTICALDATA = $__ARTICAL->read($ID);
	}

	unset($__ARTICAL);

	if (! $ARTICALDATA)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', $_SESSION['FROM']);
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('cannotread'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	$_POST = $ARTICALDATA; unset($ARTICALDATA);
	
	load_f('is_selected_unit');
	
	$view	=	new View('articalchange');

	$view	->	assign('SELF', backward());

	$view	->	assign('ARTICALCHANGE', $__LANG->get('articalchange', $ID));
	$view	->	assign('CODE', $__LANG->get('code'));
	$view	->	assign('NAME', $__LANG->get('feedstockname'));
	$view	->	assign('DIMENSIONS', $__LANG->get('dimensions'));
	$view	->	assign('UNIT', $__LANG->get('unit'));

	$__UNITS	=	new UNITloader($__CONF->get('cache', 'use_apc_cache'));
	$UNITS	 	=	$__UNITS->getall();
	$DEFAULT	=	$__UNITS->getdefault();
	unset($__UNITS, $__SQL);

	$view	->	assign('UNITS', $UNITS);
	$view	->	assign('DEFAULTUNIT', $DEFAULT);
	$view	->	assign('PRICE', $__LANG->get('price'));
	$view	->	assign('TAX', $__LANG->get('tax'));
	$view	->	assign('PURCHASEPRICE', $__LANG->get('purchase_price'));
	$view	->	assign('CURRENCY', $__CONF->get('payments', 'valuta'));
	$view	->	assign('SUPPLIER', $__LANG->get('supplier'));
	$view	->	assign('SUPPLIERID', $__LANG->get('supplierID'));
	$view	->	assign('COMMENT', $__LANG->get('comment'));
	$view	->	assign('ORIGIN', $__LANG->get('origin'));
	$view	->	assign('SEARCH', $__LANG->get('search'));

	# origin is connected with contact types
	# origin2=>dealer, type3=>Importer in contacts list

	$view	->	assign('ORIGINS', array(1=>$__LANG->get('origin1'), 2=>$__LANG->get('origin2'), 3=>$__LANG->get('origin3')));

	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('CLONE', $__LANG->get('clone'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', $_SESSION['FROM']);

	$view	->	display();

?>
