<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag bill (service list or deliverys, or both) to one customer
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('bills');

	pagepermission('bills', 'w');

	load_c('SQL');

	$__SQL	= new SQL();

	if (isset($_POST['submit']) && isset($_POST['contactID']) && $_POST['contactID'])	{

		load_m('bill2customers');

		$__BILL	=	new BILL2CUSTOMERS();

		$__BILL->addcustomers($_POST['contactID']);

		if ((isset($_POST['service_lists'])) && ($_POST['service_lists']))	$__BILL->bill_services();

		if ((isset($_POST['deliverys'])) && ($_POST['deliverys']))		$__BILL->bill_deliverys();
		
		if ((isset($_POST['only2companies'])) && ($_POST['only2companies'])) 	$__BILL->only2companies();

		$RESULT = $__BILL->create();

		$BILLID	= $__BILL->getfirstid();
		
		$ERROR = $__BILL->geterror();

		unset($__BILL, $__SQL);

		if ($RESULT !== TRUE)	{
		
			# Note: model returns translated error string

			if (isset($ERROR[0])) {$ERROR = $ERROR[0];} else {$ERROR = $__LANG->get('unknownerror');}

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $ERROR);
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}
		
		# To back to menu
		
		unset($_SESSION['FROM']);
		
		header("location: loader.php?cat=billwrited&id=$BILLID&new=bill2customer");

		exit;
	}

	# display customer select form

	load_m('customer2billread');

	$__CUSTOMERS	=	new CUSTOMERS2BILLREAD();

	$CUSTOMERS	=	$__CUSTOMERS->read();

	unset($__CUSTOMERS, $__SQL);

	if ($CUSTOMERS === FALSE)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', 'loader.php?cat=section&amp;id=bills');
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('nocustomer2billfound'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	$view	=	new View('bill2customer');

	$view	->	assign('SELF', backward());
	$view	->	assign('BILL_TO_CUSTOMER', $__LANG->get('bill2customer'));
	$view	->	assign('CONTACTNAME', $__LANG->get('contactname'));
	$view	->	assign('BILL_SERVICE_LISTS', $__LANG->get('billservicelists'));
	$view	->	assign('BILL_DELIVERYS', $__LANG->get('billdeliverys'));
	$view	->	assign('ONLY2COMPANIES', $__LANG->get('only2companies'));
	$view	->	assign('BILL', $__LANG->get('bill'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=bills');

	# form data

	$view	->	assign('CUSTOMERS', $CUSTOMERS);
	
	$view	->	display();

?>
