<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag calendar
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	# Load sql 

	load_c('SQL');

	$__SQL	= new SQL();

	# Load reminder

	# New reminder

	if (isset($_GET['id']))		{

		load_m('reminderread');

		$__REMINDER	=	new REMINDER();		

		list($YEAR, $MONTH, $DAY)	=	explode('-', $_GET['id']);

		$REMIND	=	'';
		$DATE	=	'';

		$__REMINDER->read_one($_GET['id']);

		if ($__REMINDER->RESULT->num_rows)	{

			$row	=	$__SQL->RESULT->fetch_assoc();
			$REMIND	=	$row['value'];
			$DATE	=	$row['date'];

		}

		unset($__REMINDER, $__SQL);

		if (! $DATE)	{

			$DATE	=	date($__CONF->get('date', 'dateformat'), mktime(0,0,0, $MONTH, $DAY, $YEAR));
		}

		$view	=	new View('newreminder');
		$view	->	assign('SELF', backward());
		$view	->	assign('LABEL', $__LANG->get('remlabel'));
		$view	->	assign('DATE', $DATE);
		$view	->	assign('DATE_SQL', $_GET['id']);
 		$view	->	assign('REMIND', $REMIND);
		$view	->	assign('WRITE',$__LANG->get('write'));
		$view	->	assign('DELETE', $__LANG->get('delete'));
		$view	->	assign('CANCEL', $__LANG->get('cancel'));
		$view	->	display();

		exit;
	}

	# Write new reminder to base

	load_m('reminderdates');

	$RELOAD = '';

	if (isset($_POST['delete']))  $_POST['textarea'] = '';

	if ((isset($_POST['write'])) or (isset($_POST['delete'])))  {

		load_m('reminderwrite');

		$__REMINDER	=	new REMINDERWRITE();

		$__REMINDER->write($_POST['date'], $_POST['textarea']);

		$RELOAD	=	'<script type="text/javascript">refreshparent();</script>';
	}

	if (! isset($__REMINDER))	$__REMINDER = new REMINDER();

	$__REMINDER	->	read_dates();

	$REMDATES	=	array();

	if ($__REMINDER->RESULT->num_rows)	{

		while ($row = $__REMINDER->RESULT->fetch_assoc())  $REMDATES[] = $row['date'];
	}

	unset($__REMINDER, $__SQL);

	$MONTHDAY_no	=	array(1=>31, 2=>28, 3=>31, 4=>30, 5=>31, 6=>30, 7=>31, 8=>31, 9=>30, 10=>31, 11=>30, 12=>31);
	$MONTH_name	=	array('jan', 'feb', 'mar', 'apr', 'may', 'jun', 'jul', 'aug', 'sep', 'oct', 'nov', 'dec');
	$MONTH_name_no	=	array('jan'=>1, 'feb'=>2, 'mar'=>3, 'apr'=>4, 'may'=>5, 'jun'=>6, 'jul'=>7, 'aug'=>8, 'sep'=>9, 'oct'=>10, 'nov'=>11, 'dec'=>12);
	$DAY_names	=	array('sun', 'mon', 'tue', 'wed', 'thu', 'fri', 'sat');

	$SEL_YEAR	=	'';
	$SEL_MONTH	=	'';
	$CAL_TABLE	=	'<table cellpadding="0" cellspacing="0"><tr>';

	# Select boxes

	if ((isset($_POST['year'])) or (isset($_POST['month'])))	{

		$YEAR	=	(integer)$_POST['year'];
		$MONTH	=	(integer)$MONTH_name_no[$_POST['month']];

	}	else	{

		$YEAR	=	(integer)date("Y");
		$MONTH	=	(integer)date("m");
	}

	# Left & Right

	if (isset($_GET['left']))	{

		$MONTH	=	$_GET['month']-1;
		
		$YEAR   =  	$_GET['year'];

		if (! $MONTH)	{

			$YEAR	=	$_GET['year']-1;
			$MONTH	=	12;
		}
	}

	if (isset($_GET['right']))	{	

		$MONTH	=	$_GET['month']+1;
		
		$YEAR   =  	$_GET['year'];

		if ($MONTH == 13)	{

			$YEAR	=	$_GET['year']+1;
			$MONTH	=	1;
		}
	}

	# Years select

	for ($year=1980; $year <= 2040; $year++)	{

		$selected	=	'';
		if ($year == $YEAR)	$selected='selected'; 
		$SEL_YEAR 	.=	"<option $selected value=\"$year\">\n$year\n</option>\n";
	}

	# Months select

	foreach ($MONTH_name as $month)		{

		$selected	=	'';
		if ($MONTH_name_no[$month] == $MONTH)	$selected='selected';
		$SEL_MONTH	.=	"<option $selected value=\"".$month."\">\n".$__LANG->get($month)."\n</option>\n";
	}

	# Calendar table

	foreach ($DAY_names as $day)	$CAL_TABLE .= '<td class="label" width="25">'.$__LANG->get($day)."</td>\n";

	$CAL_TABLE	=	"$CAL_TABLE</tr><tr><td height=\"7\"></td></tr>\n";

	# leap-year

	if (($YEAR % 4 == 0) or ($YEAR % 100 == 0) or ($YEAR % 400 == 0)) $MONTHDAY_no[2]=29;

	# current date & first day of month

	$C_DATE		=	date('Y-m-d');
	$W_DAY		=	date('w', mktime(0,0,0, $MONTH, 1, $YEAR));
	
	# create table

	$COL		=	0;
	$CAL_TABLE	.=	'<tr>';
	$SPAN		=	TRUE;
	$backward	=	backward();

	if ($W_DAY)	{

		$CAL_TABLE	.=	"<td colspan=\"".($W_DAY)."\"></td>\n";
		$COL		 += 	$W_DAY;
	}

	for ($DAY=1; $DAY <= $MONTHDAY_no[$MONTH]; $DAY++)	{

		if ($SPAN) {$SPAN = FALSE;} else { if (! $COL) $CAL_TABLE .= '<tr>'; }

		if (strlen($MONTH)==1) {$f_MONTH='0'.$MONTH;} else {$f_MONTH=$MONTH;}

		if ($DAY<10) {$f_DAY='0'.$DAY;} else {$f_DAY=(string)$DAY;}

		$f_DATE=$YEAR.'-'.$f_MONTH.'-'.$f_DAY;

		$class = $color = ''; $td_class = 'days';

		if (count($REMDATES))		{

			# change the color if reminder is set

			if (in_array($f_DATE, $REMDATES)) {$td_class = 'td-today'; $class = 'class="reminded"'; $color = 'style="color: #864E20;"';}
		}

		if ($C_DATE==$f_DATE) {$td_class = 'td-today'; $class = 'class="today"'; if (! $color) $color = 'style="color: #374A57;"';}

		$CAL_TABLE .= "<td class=\"$td_class\"><a $class $color href=\"$backward&amp;id=$YEAR-$MONTH-$DAY\">$DAY</a></td>\n";

		$COL++;

		if ($COL == 7) {

			$CAL_TABLE 	.=	"</tr>\n";
			$COL		 =	0;
		}
	}

	if ($COL) $CAL_TABLE .= "<td colspan=\"$COL\"></td></tr>\n";

	$CAL_TABLE .= '<tr><td height="12"></td></tr></table>';

	$view	=	new View('calendar');
	$view	->	assign('TODAY', $__LANG->get('today'));
	$view	->	assign('SELF', $backward);
	$view	->	assign('YEAR', $YEAR);
	$view	->	assign('MONTH', $MONTH);
	$view	->	assign('SEL_YEAR', $SEL_YEAR);	 unset($SEL_YEAR);
	$view	->	assign('SEL_MONTH', $SEL_MONTH); unset($SEL_MONTH);
	$view	->	assign('CAL_TABLE', $CAL_TABLE); unset($CAL_TABLE);
	$view	->	assign('RELOAD', $RELOAD);
	$view	->	display();

?>
