<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag enter into stock by order to stock
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}
	
	if (isset($_POST['stock'])) $_GET['stock'] = $_POST['stock'];

	check_year_for_write($_GET['stock']);

	pagepermission($_GET['stock'], 'w');
	
	if (isset($_POST['submit']) && isset($_POST['partially_delivered']) && ($_POST['partially_delivered']) && isset($_POST['order2stockID']))	{
	
		load_c('SQL');

		$__SQL	= new SQL();
	
		# list items on the order for select

		load_m('order2stockdata');

		$__LIST	= new ORDER2STOCKDATA();
		
		$RESULT = $__LIST->read($_POST['order2stockID']);
		
		if ($RESULT !== TRUE)	{
		
			unset($__SQL, $__LIST);

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward().'&amp;stock='.$_GET['stock']);
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
		
			exit;
		}

		$DATA =	$__LIST->get();
		
		unset($__SQL, $__LIST);
		
		load_f('encode_string_quotes');
		
		$view = new View('order2stockpart');
		
		$view	->	assign('SELF', backward().'&amp;stock='.$_GET['stock']);
		$view	->	assign('ORDER2STOCK', $__LANG->get('partorder2stocknumber', $_POST['order2stockID']));
		$view	->	assign('DATA', $DATA); unset($DATA);
		$view	->	assign('SUPPLIER', $__LANG->get('supplier'));
		$view	->	assign('DATE_OF_ORDER',  $__LANG->get('date_of_order'));
		$view	->	assign('COLUMNCODE', $__LANG->get('columnname_code'));
		$view	->	assign('COLUMNNAME', $__LANG->get('columnname_name'));
		$view	->	assign('COLUMNQUANTITY', $__LANG->get('columnname_quantity'));
		$view	->	assign('COLUMNUNIT', $__LANG->get('columnname_unit'));
		$view	->	assign('WRITE', $__LANG->get('write'));
		$view	->	assign('RESET', $__LANG->get('reset'));
		$view	->	assign('CANCEL', $__LANG->get('cancel'));
		
		$view 	->	display();

		exit;
	}

	if (isset($_POST['submit']))	{
	
		load_c('SQL');

		$__SQL	= new SQL();
	
		if (isset($_POST['partially_selected']))	{
		
			  load_m('enterbyorderpart');

			  $__ENTER	=	new ENTERBYORDERPART();
			  
		}	else	  {

			  load_m('enterbyorder');

			  $__ENTER	=	new ENTERBYORDER();
		}

		$RESULT		=	$__ENTER->write($_POST);
		
		unset($__ENTER, $__SQL);

		if ($RESULT !== TRUE)	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward().'&amp;stock='.$_GET['stock']);
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('order2stockentered', $_POST['order2stockID']));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', backward().'&amp;stock='.$_GET['stock']);
		$view	->	display();
		exit;
	}

	$view = new View('orderedenter');

	$view	->	assign('SELF', backward());
	$view	->	assign('STOCK', $_GET['stock']);
	$view	->	assign('ORDERED_ENTER_TO_STOCK', $__LANG->get('orderedenter'));
	$view	->	assign('ORDER2STOCK_ID',  $__LANG->get('personIDlong'));
	$view	->	assign('SUPPLIER',  $__LANG->get('supplier'));
	$view	->	assign('DATE_OF_ORDER',  $__LANG->get('date_of_order'));
	$view	->	assign('BILL_NUMBER',  $__LANG->get('bill_number'));
	$view	->	assign('DELIVERY_LIST_NUMBER',  $__LANG->get('delivery_list_number'));
	$view	->	assign('PARTIALLY_DELIVERED_ORDER',  $__LANG->get('deliveredpartially'));
	$view	->	assign('ERRORMSG',  $__LANG->get('unorderedorder2stock'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id='.$_GET['stock']);

	$view	->	display();
	
?>
