<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag feedstock direct enter change
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('feedstock');

	pagepermission('feedstock', 'w');

	if (isset($_GET['id']))	{

		$ENTERID	=	$_GET['id'];

	}	else	{

		$ENTERID	=	$_POST['enterid'];
	}

	load_c('SQL');

	$__SQL	= new SQL();

	if (isset($_POST['submit']))	{

		load_m('directstockenterupdate');

		$__ENTER	=	new STOCKENTERUPDATE('feedstock');

		$RESULT		=	$__ENTER->update($ENTERID, $_POST);
		
		$newID		=	$__ENTER->getnewID();

		unset($__ENTER, $__SQL);

		if ($RESULT !== TRUE)	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward()."&amp;id=$ENTERID");
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}
		
		if ($newID) {$rewrited = ' '.$__LANG->get('enterrewrited', $newID);} else {$rewrited = '';}

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('enterchanged', $ENTERID).$rewrited);
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', $_SESSION['FROM']);
		$view	->	display();
		exit;
	}

	load_m('stockenterread');

	$__ENTER	=	new STOCKENTERREAD('feedstock');

	$ENTERDATA	=	$__ENTER->read($ENTERID);

	unset ($__ENTER);

	if (! $ENTERDATA)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', $_SESSION['FROM']);
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('cannotread'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	load_m('idsearch');

	$search	=	new IDSEARCH();

	$ITEMID	=	$search	->	bycode('ebagstock.feedstock', $ENTERDATA['code']);

	unset($search, $__SQL);

	$view	=	new View('enterquantitychange');
	
	$view	->	assign('ENTER_ORIGIN_AND_QUANTITY', $__LANG->get('changeenteroriginquantity', $ENTERID));
	$view	->	assign('PERSONID', $__LANG->get('personIDlong'));
	$view	->	assign('CODE', $__LANG->get('code'));
	$view	->	assign('NAME', $__LANG->get('feedstockname'));
	$view	->	assign('UNIT', $__LANG->get('unit'));
	$view	->	assign('BILL_NUMBER', $__LANG->get('bill_number'));
	$view	->	assign('DELIVERY_LIST_NUMBER', $__LANG->get('delivery_list_number'));
	$view	->	assign('QUANTITY', $__LANG->get('quantity'));
	$view	->	assign('STOCKITEMNAME', 'feedstockname');

	# form data

	$view	->	assign('ITEMID', $ITEMID);
	$view	->	assign('ITEMCODE', $ENTERDATA['code']);
	$view	->	assign('ITEMNAME', $ENTERDATA['feedstockname']);
	$view	->	assign('ITEMUNIT', $ENTERDATA['unit']);

	$_POST['bill_number']		=	$ENTERDATA['bill_number'];
	$_POST['delivery_list_number']	=	$ENTERDATA['delivery_list_number'];
	$_POST['quantity']		=	$ENTERDATA['quantity'];
	$_POST['enterid']		=	$ENTERID;

	unset($ENTERDATA);

	$view 	->	assign('WRITE', $__LANG->get('write'));
	$view 	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('BACKTO', $_SESSION['FROM']);
	$view 	->	assign('CANCEL', $__LANG->get('cancel'));	

	$view	->	display();

?>
