<?php
    	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 *	Start new installation
	 */

	include('installationconf.php');
	
	if (! isset($_GET['lang'])) 	 $_GET['lang'] = 'eng';
	
	if (! isset($_GET['direction'])) $_GET['direction'] = 'ltr';

	if (isset($_POST['next']))	{
	
		header('location: installationprecheck.php?lang='.$_POST['lang'].'&direction='.$_POST['direction']);
		
		exit;
	}

	# read avialable languages
	
	load_f('getlanguages');
	
	$languages = getlanguages();

	if (! in_array($_GET['lang'], $languages)) exit('Fatal error: language file '.$_GET['lang'].' not found !');
	
	# load language
	
	load_f('loadlanguage');
	
	$__LANG = loadlanguage('install', $_GET['lang']);

	# show the installation window
	
	load_c('View');
	
	$view = new View('install');
	
	$view->assign('SELF', url_encode($_SERVER['PHP_SELF']));
	$view->assign('LANGUAGE', $__LANG['language']);
	$view->assign('LANGUAGES', $languages);
	$view->assign('WELCOME', $__LANG['welcome']);
	$view->assign('INSTALL_TEXT', $__LANG['install_text']);
	$view->assign('CANCEL', $__LANG['cancel']);
	$view->assign('NEXT', $__LANG['next']);

	$view ->display();
?>