<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag Login
	 */

	# Check installation
	 
	if (! is_file('../conf/installed.conf'))	{
	 
		header("location: ../controllers/install.php");
		  
		exit;
	}
	
	# Start
	
	ob_start('ob_gzhandler');
	
	define ('BASEDIR', '../');
	
	set_time_limit(300);
	
	clearstatcache(TRUE);

	# Load basic functions

	require(BASEDIR.'helpers/basichelpers.php');

	# Reads the configuration

	load_c('INIload');

	$__CONF	=	new INI_load(BASEDIR.'conf/eBag.ini');
	
	# If the page is direct requested (not redirected by index) check the protocol
	
	if ($__CONF->get('protocol', 'type') == 'https')	{
	
		# note:	$SERVER_SECURE_PORT is set only because of compatibility
		# 	with configuration file older than 3.0.6 (important)
		
		if ($__CONF->get('protocol', 'secure_port')) {$SERVER_SECURE_PORT = $__CONF->get('protocol', 'secure_port');} else {$SERVER_SECURE_PORT = 443;}

		if (isset($_SERVER['SERVER_PORT']) && (($_SERVER['SERVER_PORT'] != $SERVER_SECURE_PORT)))	{

			header("location: ../index.php");

			exit;
		}
	}

	# Start error handler

	load_c('Errorhandler');

	$__HANDLER	=	new ERRHANDLER();
	$__HANDLER	->	start();

	# Loads the language
	
	load_c('Language');
	
	$lang 	= strtolower($__CONF->get('language', 'lang'));

	$__LANG	 = new Lang(BASEDIR."lang/$lang/language.$lang", $__CONF->get('cache', 'use_apc_cache'));
	
	unset($lang);

	# The users cannot log in when maintenance is in progress

	$filemark = BASEDIR.'tmp/maintenance.conf';
	
	# Remove previous cookie if found
	
	setcookie('eBAG_DO_BACKUP', '',time()-3600);
	
	if (is_file($filemark)) 	{
	
		if  ((filemtime($filemark) + 10800) > time())	{

			$MAINTENANCE = $__LANG->get('maintenanceinprogress');
			
			include(BASEDIR.'views/maintenance.php');

			exit;
			  
		}	else	  {
		
			# something is wrong, the maintenance is not finished over 3 hours
			# step over backup to not overwrite it, and call for administrator
			
			$maintenance_error = TRUE;
		}
	}

	load_c('View');

	# Validate
	
	if (isset($_POST['login_SUB']))	{

		# Sets session handler

		load_c('Sessionhandler');

		$__SESS	=	new MysqlSession();
		$__SESS	->	set_session_handler();
		
		register_shutdown_function('session_write_close');

		# Turn off magic quotes runtime

		if (get_magic_quotes_runtime())	set_magic_quotes_runtime(false);

		# If magic quotes is enabled strip slashes form GETS and POSTS

		if (get_magic_quotes_gpc()) {

			if (isset($_POST) && $_POST)	{

			      foreach($_POST as $key=>$val) $_POST[$key] = stripslashes($val);
			}

			if (isset($_GET) && $_GET)	{

			      foreach($_GET as $key=>$val) $_GET[$key] = stripslashes($val);
			}
		}

		# Start the session

		session_start();
		
		session_regenerate_id();
		
		load_c('SQL');

		$__SQL	=	new SQL;

		$username	=	$__SQL->escape($_POST['username']);
		$password	=	md5($_POST['password']);

		$__SQL->query("	SELECT `personID`, `permission`, `surname`, `lastname` 
				FROM ebag.users 
				WHERE `username`='$username' AND `password`='$password' AND `deleted` IS NOT NULL LIMIT 1");

		if ($__SQL->num_rows())		{
		
			$row = $__SQL->RESULT->fetch_assoc();
			
			$userID = $__SQL->escape($row['personID']);

		 	# Check the user is logged before & log in

			if (! $__SESS->is_logged($userID))	{

				$__SESS	-> login($userID);

				$_SESSION['userID'] 		=	$row['personID'];
				$_SESSION['user']		=	$row['surname'].' '.$row['lastname'];
				$_SESSION['username']		=	$_POST['username'];
				$_SESSION['permission']		=	$row['permission'];
				$_SESSION['p_format']		=	"A4";
				$_SESSION['p_orientation']	=	"L";
				$_SESSION['list_limit']		=	"1000";

				# Read last year, last discount, last number of copies from base

				# year & year is closed

				$__SQL->query("	SELECT MAX(`year`) AS `year` 
						FROM ebag.years	");

				if ($__SQL->num_rows())		{

					list($_SESSION['year'])	= $__SQL->RESULT->fetch_row();

					$__SQL->query("	SELECT `year` 
							FROM ebag.years 
							WHERE `year`='".$_SESSION['year']."' AND `closed` is NOT NULL LIMIT 1");

					if ($__SQL->num_rows())	$_SESSION['year_is_closed']='TRUE';

				}	else	{

					exit($__LANG->get('not_installed'));
				}

				# discount

				$__SQL->query("	SELECT `value` 
						FROM ebag.settings 
						WHERE `key`='discount'	");

				list($_SESSION['discount']) = $__SQL->RESULT->fetch_row();
				
				# set the device selection cookie for 5 years
				
				setcookie('eBagDeviceType', $_POST['device'], time()+157680000);
				
				# set cookies to main
				
				setcookie('eBAG_VERSION_NUMBER', VERSION_NUMBER, 0);
				setcookie('eBAG_TEXT_DIRECTION', TEXT_DIRECTION, 0);
				
				# set redirection url depending of the device & set device session variable
				
				switch($_POST['device'])	{
				
					case('m')	:	$_SESSION['mobiledevice'] = TRUE;
					
								$redirect = 'location: '.BASEDIR.'controllers/loader.php?cat=mobile_home';
					
								break;
							
					default		:	$redirect = 'location: '.BASEDIR.'controllers/main.php';
				}
				
				# backup or not
				
				if ($__CONF->get('backup', 'daily_backup') && $__CONF->get('backup', 'directory') &&  (! isset($maintenance_error))) setcookie('eBAG_DO_BACKUP', '1', 0);
				
				# redirect to main

				header($redirect);

				exit;
			}

			$REPORT='is_logged';

		}	else	 {

			$REPORT='notmatch';
		}
	}

	# Show the login form

	$view		=	new View('login');
	
	load_f('url_encode');
	
	if (isset($_SERVER['SCRIPT_NAME'])) {$SELF = $_SERVER['SCRIPT_NAME'];} else {$SELF = $_SERVER['PHP_SELF'];}
	
	$view->assign('SELF', url_encode($SELF));
	$view->assign('LOGINTXT', $__LANG->get('logintxt'));
	$view->assign('USERNAME', $__LANG->get('username'));
	$view->assign('PASSWORD', $__LANG->get('password'));
	$view->assign('LOGIN', 	  $__LANG->get('login'));
	
	$view->assign('DEVICE',	  $__LANG->get('device'));
	$view->assign('DESKTOP',  $__LANG->get('desktop'));
	$view->assign('MOBILEPHONE', $__LANG->get('mobilephone'));
	
	# Note : devices -> d = desktop PC ; m = mobilephone
	
	if (isset($_COOKIE['eBagDeviceType']))	{
	
		$DEVICE_TYPE = $_COOKIE['eBagDeviceType'];
		
	}	else	  {
	
		$DEVICE_TYPE = 'd';
	}
	
	$view->assign('DEVICE_TYPE', $DEVICE_TYPE);
	
	$view->assign('COOKIE_WARNING', $__LANG->get('cookiewarning'));
	
	if (isset($REPORT)) {$REPORT = $__LANG->get($REPORT);} else {$REPORT = '';}
	
	$view->assign('REPORT',  $REPORT);

	$view->display();
?>
