<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag create new order
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('orders');

	pagepermission('orders', 'w');
	
	load_c('SQL');

	$__SQL	=  new SQL;

	if (isset($_POST['submit']))	{

		load_m('orderwrite');

		$__ORDER	=	new ORDERWRITE();

		unset($_POST['submit']);

		$RESULT		=	$__ORDER->write($_POST);

		$NEWID 		=	$__ORDER->getid();

		$ORDER2STOCK	=	$__ORDER->ORDER_TO_STOCK;

		unset($__SQL, $__ORDER);

		if ($RESULT !== TRUE)	{

			$_POST['_err_address'] = backward();
			
			$_SESSION['_POST_ERR']	=  $_POST;

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_POST['_err_address'].'&amp;p_err=1');
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		if ($ORDER2STOCK)	{

			header("location: loader.php?cat=order2stock_from_sell&id=$NEWID");
			exit;
		}

		header("location: loader.php?cat=orderwrited&id=$NEWID");
		
		exit;
	}

	$__PAYMENTS	=	new PAYMENTloader($__CONF->get('cache', 'use_apc_cache'));

	$PAYMENT_FORMS		=	$__PAYMENTS->getnames();
	$DEFAULT_PAYMENT	=	$__PAYMENTS->getdefault();

	unset($__PAYMENTS);

	$__DELIVERYS	=	new DELIVERYloader($__CONF->get('cache', 'use_apc_cache'));

	$DELIVERY_TYPES		=	$__DELIVERYS->gettypes();
	$DEFAULT_DELIVERY	=	$__DELIVERYS->getdefault();

	unset($__DELIVERYS);	

	$view	=	new View('order');
	$view	->	assign('SELF', backward());

	$view	->	assign('ORDERLABEL', $__LANG->get('neworder'));
	$view	->	assign('CONTACTID', $__LANG->get('contactID'));
	$view	->	assign('CONTACTNAME', $__LANG->get('contactname'));
	$view	->	assign('DEADLINE', $__LANG->get('deadline'));
	$view	->	assign('PAYMENT_FORM', $__LANG->get('payment_form'));
	$view	->	assign('DELIVERY_FORM', $__LANG->get('delivery_form'));
	$view	->	assign('SESSIONDISCOUNT', $__LANG->get('session_discount'));
	$view	->	assign('ARTICLEDISCOUNT', $__LANG->get('article_discount_in'));
	$view	->	assign('CALCULATEINVALUTA', $__LANG->get('calculate_in_valuta'));
	$view	->	assign('DAYSWORD', $__LANG->get('daysword'));
	$view	->	assign('COLUMNCODE', $__LANG->get('columnname_code'));
	$view	->	assign('COLUMNNAME', $__LANG->get('columnname_name'));
	$view	->	assign('COLUMNQUANTITY', $__LANG->get('columnname_quantity'));
	$view	->	assign('COLUMNUNIT', $__LANG->get('columnname_unit'));
	$view	->	assign('COLUMNTAX', $__LANG->get('columnname_tax'));
	$view	->	assign('COMMENT', $__LANG->get('comment'));
	$view	->	assign('ANNOTATION', $__LANG->get('annotation'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('SEARCH', $__LANG->get('search'));
	$view	->	assign('SUMMARY', $__LANG->get('summary'));
	$view	->	assign('PRICETXT', $__LANG->get('price'));
	$view	->	assign('USED_SESSION_DISCOUNT', $__LANG->get('used_session_discount'));
	$view	->	assign('USED_ARTICLE_DISCOUNT', $__LANG->get('used_article_discount'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=orders');
	$view	->	assign('CANCEL', $__LANG->get('cancel'));

	# form data

	$view	->	assign('PAYMENT_FORMS', $PAYMENT_FORMS); unset($PAYMENT_FORMS);
	$view 	->	assign('DELIVERY_TYPES', $DELIVERY_TYPES); unset($DELIVERY_TYPES);

	# Write back the post if error was

	if (post_get_data_verified())	{

		$_POST = enc_quotes($_SESSION['_POST_ERR']);
		
		unset($_SESSION['_POST_ERR']);
	}

	# new

	if ((! isset($_POST)) or (! count($_POST)))	{

		$_POST['use_session_discount']	= 	'on';

		$_POST['use_article_discount']	= 	'on';

		$_POST['session_discount'] 	= 	$_SESSION['discount'];

		$_POST['payment_form']		=	$DEFAULT_PAYMENT; unset($DEFAULT_PAYMENT);

		$_POST['delivery_form']		=	$DEFAULT_DELIVERY; unset($DEFAULT_DELIVERY);

		$_POST['deadline_days']		=	$__CONF->get('delivery', 'default_deadline_for_shipment');

		$_POST['tax'] 			= 	(integer)str_replace('%', '', $__CONF->get('tax', 'sales_tax'));

		$_POST['exchange_rate']		= 	$__CONF->get('payments', 'exchange_rate');
		$_POST['currency']		= 	$__CONF->get('payments', 'currency');
		$_POST['valuta']		= 	$__CONF->get('payments', 'valuta');
	}

	unset($__SQL);
	
	$view	->	display();

?>
