<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 5.0.0
	 */

	/**
	 * eBag order to stock details
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	pagepermission('orders', 'r');

	load_c('SQL');

	$__SQL 	= new SQL;

	load_m('order2stockdetails');

	$__ORDER2STOCK	=	new ORDER2STOCKDETAILS();

	# if year is set change base to read

	if (isset($_GET['year'])) $__ORDER2STOCK->base('ebagdata'.$_GET['year']);

	$ORDER2STOCKDATA = $__ORDER2STOCK->read($_GET['id']);

	unset($__ORDER2STOCK, $__SQL);

	if (! $ORDER2STOCKDATA)		{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', $_SESSION['FROM']);
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('unexistentorder2stock'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	$view	=	new View('order2stockdetails');

	$view	->	assign('SELF', backward());
	$view	->	assign('ORDER2STOCKDETAILS', $__LANG->get('order2stockdetails', $_GET['id'].'/'.$ORDER2STOCKDATA['order2stock_year']));
	$view	->	assign('ORDER2STOCKID', $_GET['id']);
	$view	->	assign('CONTACTNAME', $__LANG->get('contactname'));
	$view	->	assign('COUNTRY', $__LANG->get('country'));
	$view	->	assign('CITY', $__LANG->get('city'));
	$view	->	assign('ZIP', $__LANG->get('zip'));
	$view	->	assign('STREET', $__LANG->get('street'));
	$view	->	assign('DATE_OF_ORDER', $__LANG->get('date_of_order'));
	$view	->	assign('CONNECTED_WITH_ORDERS', $__LANG->get('connected_with_short'));
	$view	->	assign('COMMENT', $__LANG->get('comment'));
	$view	->	assign('COLUMNCODE', $__LANG->get('columnname_code'));
	$view	->	assign('COLUMNNAME', $__LANG->get('columnname_name'));
	$view	->	assign('COLUMNQUANTITY', $__LANG->get('columnname_quantity'));
	$view	->	assign('COLUMNUNIT', $__LANG->get('columnname_unit'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('PRINT', $__LANG->get('print'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', $_SESSION['FROM']);

	# form data

	$view	->	assign('DATA', $ORDER2STOCKDATA); unset($ORDER2STOCKDATA);

	$view	->	display();	

?>
