<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag order change
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('orders');

	pagepermission('orders', 'w');

	if (isset($_GET['id']))		{

		$ORDERID = $_SESSION['ID'] = $_GET['id'];

	}	else	  {

		$ORDERID = $_SESSION['ID'];
	}

	load_c('SQL');

	$__SQL	= new SQL;

	if (isset($_POST['submit']))	{

		load_m('orderupdate');

		$__ORDER	=	new ORDERUPDATE();

		unset($_POST['submit']);

		$RESULT		=	$__ORDER->update($ORDERID, $_POST);

		$ORDER2STOCK	=	$__ORDER->ORDER_TO_STOCK;

		unset($__SQL, $__ORDER);

		if ($RESULT !== TRUE)	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward()."&amp;id=$ORDERID");
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		if ($ORDER2STOCK)	{

			header("location: loader.php?cat=order2stock_from_sell&change=true&id=$ORDERID");
			exit;
		}

		header("location: loader.php?cat=orderupdated&id=$ORDERID");

		exit;
	}

	# read order data
	# because of locked rows the $_POST if part of order
	# so is better to reread all from base on error to

	load_m('orderread');

	$__ORDER	=	new	ORDERREAD();
	$_POST		=	$__ORDER->read($ORDERID);

	unset($__ORDER);

	if (! is_array($_POST))		{

		$view	=	new View('errorbox');
		$view	->	assign('SELF',  $_SESSION['FROM']);
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get($_POST));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	$__PAYMENTS	= new PAYMENTloader($__CONF->get('cache', 'use_apc_cache'));

	$PAYMENT_FORMS	= $__PAYMENTS->getnames();

	unset($__PAYMENTS);

	$__DELIVERYS	= new DELIVERYloader($__CONF->get('cache', 'use_apc_cache'));

	$DELIVERY_TYPES	= $__DELIVERYS->gettypes();

	unset($__DELIVERYS);	

	$view	=	new View('order');
	$view	->	assign('SELF', backward());

	$view	->	assign('ORDERLABEL', $__LANG->get('orderchange', $ORDERID.'/'.$_POST['order_year']));
	$view	->	assign('ORDERID', $ORDERID);
	$view	->	assign('CONTACTID', $__LANG->get('contactID'));
	$view	->	assign('CONTACTNAME', $__LANG->get('contactname'));
	$view	->	assign('DEADLINE', $__LANG->get('deadline'));
	$view	->	assign('PAYMENT_FORM', $__LANG->get('payment_form'));
	$view	->	assign('DELIVERY_FORM', $__LANG->get('delivery_form'));
	$view	->	assign('SESSIONDISCOUNT', $__LANG->get('session_discount'));
	$view	->	assign('ARTICLEDISCOUNT', $__LANG->get('article_discount_in'));
	$view	->	assign('CALCULATEINVALUTA', $__LANG->get('calculate_in_valuta'));
	$view	->	assign('DAYSWORD', $__LANG->get('daysword'));
	$view	->	assign('COLUMNCODE', $__LANG->get('columnname_code'));
	$view	->	assign('COLUMNNAME', $__LANG->get('columnname_name'));
	$view	->	assign('COLUMNQUANTITY', $__LANG->get('columnname_quantity'));
	$view	->	assign('COLUMNUNIT', $__LANG->get('columnname_unit'));
	$view	->	assign('COLUMNTAX', $__LANG->get('columnname_tax'));
	$view	->	assign('COMMENT', $__LANG->get('comment'));
	$view	->	assign('ANNOTATION', $__LANG->get('annotation'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('SEARCH', $__LANG->get('search'));
	$view	->	assign('SUMMARY', $__LANG->get('summary'));
	$view	->	assign('PRICETXT', $__LANG->get('price'));
	$view	->	assign('USED_SESSION_DISCOUNT', $__LANG->get('used_session_discount'));
	$view	->	assign('USED_ARTICLE_DISCOUNT', $__LANG->get('used_article_discount'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('BACKTO', $_SESSION['FROM']);
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('PAYMENT_FORMS', $PAYMENT_FORMS); unset($PAYMENT_FORMS);
	$view 	->	assign('DELIVERY_TYPES', $DELIVERY_TYPES); unset($DELIVERY_TYPES);
	
	unset($__SQL);

	$view	->	display();

?>
