<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag print table results
	 */

	# note: because of performance tables print will be done with css

	ob_start('ob_gzhandler');

	define('BASEDIR', '../');
	
	# Set time limit
	
	set_time_limit(600);

	# Reads the configuration

	require(BASEDIR.'classes/INIload.class.php');
	
	require(BASEDIR.'classes/Language.class.php');
	
	require(BASEDIR.'classes/UNITloader.class.php');

	require(BASEDIR.'classes/PAYMENTloader.class.php');

	require(BASEDIR.'classes/DELIVERYloader.class.php');
	
	require(BASEDIR.'classes/PHASEloader.class.php');
	
	# Sets mbstring functions
	
	mb_internal_encoding('UTF-8');
	
	mb_regex_encoding('UTF-8');

	# Load the configuration

	$__CONF	=	new INI_load(BASEDIR.'conf/eBag.ini');
	
	# Sets error handler

	require(BASEDIR.'classes/Errorhandler.class.php');

	$__HANDLER	=	new ERRHANDLER();
	$__HANDLER	->	start();

	# Sets session handler

	require(BASEDIR.'classes/Sessionhandler.class.php');

	$__SESS	=	new MysqlSession();
	$__SESS	->	set_session_handler();
	
	register_shutdown_function('session_write_close');

	session_start();

	# Loads language
	
	$lang 	= strtolower($__CONF->get('language', 'lang'));

	$__LANG	= new Lang("../lang/$lang/language.$lang", $__CONF->get('cache', 'use_apc_cache'));
	
	unset($lang);

	# Turn off magic quotes runtime

	if (get_magic_quotes_runtime())	set_magic_quotes_runtime(false);

	# Define essential constants

	$PRINTYPE	=	$_GET['id'];

	if (isset($_SESSION['year_is_closed']))	{$YEARCLOSED = TRUE;} else {$YEARCLOSED = FALSE;}

	if (isset($_SESSION['year']))		$BASE = 'ebagdata'.$_SESSION['year'];

	if (isset($_SESSION['DROPTABLE1']))	$DROPTABLE1	=	$_SESSION['DROPTABLE1'];

	if (isset($_SESSION['DROPTABLE2']))	$DROPTABLE2	=	$_SESSION['DROPTABLE2'];

	if (isset($_SESSION['DROPTABLE3']))	$DROPTABLE3	=	$_SESSION['DROPTABLE3'];

	if (isset($_SESSION['TEMPTABLE1']))	$TEMPTABLE1	=	$_SESSION['TEMPTABLE1'];

	if (isset($_SESSION['TEMPTABLE2']))	$TEMPTABLE2	=	$_SESSION['TEMPTABLE2'];

	if (isset($_SESSION['TEMPTABLE3']))	$TEMPTABLE3	=	$_SESSION['TEMPTABLE3'];

	if (isset($_SESSION['COMMAND']))	$COMMAND 	=	$_SESSION['COMMAND'];

	if (isset($_SESSION['LIMIT']))		$LIMIT		=	$_SESSION['LIMIT'];

	if ((! isset($BASE)) or (! isset($COMMAND))) exit($__LANG->get('sessionexpired'));

	require(BASEDIR.'classes/SQL.class.php');

	$__SQL	= new SQL();

	# define function to localize values

	function localize($VALUE, $COLUMN)	{

		global $__LANG, $__SQL, $BASE, $DELIVERY_TYPES, $PAYMENT_TYPES, $PHASES;

		switch($COLUMN)		{

			case('contacttype')		:	$TXT = $__LANG->get("type$VALUE");
								break;

			case('delivery_day_of_week')	:	$TXT = $__LANG->get("day$VALUE");
								break;

			case('critic')			:	$TXT = $__LANG->get("critic$VALUE");
								break;

			case('origin')			:	$TXT = $__LANG->get("origin$VALUE");
								break;

			case('delivered')		:	$TXT = $__LANG->get("deliverystate$VALUE");
								break;

			case('ordered')			:
			case('billed')			:
			case('finished')		:	$TXT = $__LANG->get("yesno$VALUE");
								break;

			case ('connected_with_deliverys'):
			case ('connected_with_reverses'):
			case ('connected_with_orders')	:	if (! $VALUE)	{

									$TXT = $VALUE;
									break;
								}

								$LIST	=	explode('-', $VALUE);

								unset($LIST[count($LIST)-1], $LIST[0]);

								$TXT	=	wordwrap(implode(', ', $LIST), 20, "<br>");

								break;

			case ('delivery_form')		:	$TXT		=	'';

								if (isset($DELIVERY_TYPES[$VALUE]))	$TXT = $DELIVERY_TYPES[$VALUE];
							
								break;

			case ('payment_form')		:	$TXT		=	'';
			
								if (isset($PAYMENT_TYPES[$VALUE]))	$TXT= $PAYMENT_TYPES[$VALUE];
								
								break;

			case ('production_phase')	:	$TXT	=	'';

								if (isset($PHASES[$VALUE]))	$TXT = $PHASES[$VALUE];
							
								break;

			case('finisher')		:	if (! $VALUE)	{

									$TXT = $VALUE;
									break;
								}

								list($TYPE, $FINISHERID)	=	explode('_', $VALUE);

								if ($TYPE == 'employee')	{

									$COMMAND = "SELECT `employeename` FROM $BASE.employees WHERE `personID`='$FINISHERID' AND `deleted` IS NOT NULL LIMIT 1";

								}	else	   {

									$COMMAND = "SELECT `contactname` FROM $BASE.addressbook WHERE `personID`='$FINISHERID' AND `deleted` IS NOT NULL LIMIT 1";
								}

								$__SQL->query($COMMAND);

								if ($__SQL->num_rows())	{

									$RESULT	= $__SQL->RESULT->fetch_row();
									$TXT = $RESULT[0];

								}	else	  {

									$TXT = $__LANG->get('finisherwasdeleted');
								}

								break;

			case('month')			:	$TXT = $__LANG->get("monthname$VALUE");
								break;
								
									
			case('month_part')		:	if ($VALUE == 1) {$TXT = 'I';} elseif ($VALUE == 2) {$TXT = 'II';} else {$TXT = 'I-II';}
								break;

			case('seller')			:	if ($VALUE)	{

									$__SQL->query("	SELECT `employeename` 
											FROM $BASE.employees
											WHERE `personID`='$VALUE' LIMIT 1	");

									if ($__SQL->num_rows())	{
				
										$RESULT =	$__SQL->RESULT->fetch_row();
										$TXT	=	$RESULT[0];
									}
								}

								if (! isset($TXT)) $TXT =	$__LANG->get('notset');

								break;

			default				:	$TXT = $VALUE;
		}

		return $TXT;
	}
	
	# read arrays (unfortunely must here because it will break the loop)
	
	$__DELIVERYS = new DELIVERYloader($__CONF->get('cache', 'use_apc_cache'));

	$DELIVERY_TYPES	= $__DELIVERYS->gettypes();
										
	unset($__DELIVERYS);
				
	$__PAYMENTS = new PAYMENTloader($__CONF->get('cache', 'use_apc_cache'));

	$PAYMENT_TYPES	= $__PAYMENTS->getnames();
										
	unset($__PAYMENTS);								
										
	$__PHASES = new PHASEloader($__CONF->get('cache', 'use_apc_cache'));

	$PHASES = $__PHASES->getall();
	
	unset($__PHASES);

	# select current base (commandline need it)

	$__SQL->mysqli->select_db($BASE);

	if (($PRINTYPE == 'view') && (isset($LIMIT))) $COMMAND .= $LIMIT;

	# note: first execute temporary tables if exists

	if (isset($DROPTABLE1)) $__SQL->query($DROPTABLE1);

	if (isset($DROPTABLE2)) $__SQL->query($DROPTABLE2);

	if (isset($DROPTABLE3)) $__SQL->query($DROPTABLE3);

	if (isset($TEMPTABLE1)) $__SQL->query($TEMPTABLE1);
	
	if (isset($TEMPTABLE2))	$__SQL->query($TEMPTABLE2);

	if (isset($TEMPTABLE3))	$__SQL->query($TEMPTABLE3);

	$__SQL->query($COMMAND);

	if ($__SQL->num_rows())		{

		$TO_LOCALIZE	=	array(	'contacttype', 'delivery_day_of_week', 'critic', 'origin', 'ordered', 'finished', 'finisher', 'delivered', 
						'delivery_form', 'payment_form', 'connected_with_orders', 'connected_with_deliverys', 'month', 'month_part',
						'connected_with_reverses', 'production_phase', 'billed', 'seller' );

		$COLUMNS	=	array();

		while ($FINFO = $__SQL->RESULT->fetch_field()) array_push($COLUMNS, $FINFO->name);

		if (count($COLUMNS))	{
		
			$VERSION_NUMBER = VERSION_NUMBER;
			
			$TEXT_DIRECTION = TEXT_DIRECTION;

			echo	<<<"EOT"
				<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
				<html>
					<head>
						<meta http-equiv="Content-Type" CONTENT="text/html; charset=utf-8">
				 		<meta name="robots" content="noindex,nofollow">
						<title>eBag</title>
						<link href="../css/$TEXT_DIRECTION/tableprint.css?ver=$VERSION_NUMBER" rel="stylesheet" type="text/css" media="print,screen">
					</head>
				<body>
EOT;

			echo "<table>\n";

			include (BASEDIR.'functions/mb_wrap.php');

			echo "<thead><tr>\n";

			foreach ($COLUMNS as $COLUMN)	echo "<td class=\"bottom\">".mb_wrap($__LANG->get($COLUMN), 7, '<br>')."</td>\n";

			echo "</tr></thead><tbody>\n";

			$inc	=	0;

			ob_start();

			$__SQL->IT1_RESULT = $__SQL->RESULT;

			while ($ROW = $__SQL->IT1_RESULT->fetch_assoc())	{

				echo "<tr>\n";

				foreach ($COLUMNS as $COLUMN)	{

					$VALUE	= $ROW[$COLUMN];

					if (in_array($COLUMN, $TO_LOCALIZE)) $VALUE = localize($VALUE, $COLUMN);

					echo "<td>$VALUE</td>\n";
				}

				echo "</tr>\n";

				$inc++;

				if ($inc == 100)	{

					ob_end_flush();
					ob_start();
					$inc = 0;
					sleep(1);
				}
			}
	
			echo "</tbody></table></body></html>\n";

			ob_end_flush();
		}

		unset($__SQL->IT1_RESULT);

		$__SQL->free();

		if (isset($DROPTABLE1)) $__SQL->query($DROPTABLE1);

		if (isset($DROPTABLE2)) $__SQL->query($DROPTABLE2);

		if (isset($DROPTABLE3)) $__SQL->query($DROPTABLE3);

		exit();		
	}

	$MESSAGE = $__LANG->get('printqueryempty');

	include(BASEDIR.'views/printqueryempty.php');

?>

