<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 *	eBag production order search by dates
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	pagepermission('production', 'r');

	# Delete previous search data

	if (isset($_GET['new']))	{

		$_SESSION['LISTPAGE']	=	0;

		if (isset($_SESSION['COMMAND'])) unset($_SESSION['COMMAND'], $_SESSION['LIMIT']);

		unset($_GET['new']);
	}

	if (	(isset($_POST['submit'])) or 
		(isset($_SESSION['COMMAND']))	)		{

			unset($_POST['submit']);

			load_c('SQL');

			$__SQL	= new SQL();

			load_c('TIMING');

			$search		=	new TIMING($_SESSION['BASE'].'.production_orders_header', $_GET['cat'], 'productionorderdetails', 'productionorderchange', 'productionorderdelete', PAGEINCREMENT, $_SESSION['list_limit']);
			$COLUMNS	=	array('personID', 'code', 'articalname', 'contactname', 'orderID', 'date_of_deadline', 'finished', 'production_phase');
			$search		->	column($COLUMNS);

			if (! isset($_POST)) $_POST=array();

			$search->addsearch($_POST); unset($_POST);

			$_SESSION['FROM']	=	backward();

			if ($search->create())	{

				$HTMLTABLE	=	&$search->TABLE;

				$view	=	new View('tablesearch');
				$view 	->	assign('HTMLTABLE', $HTMLTABLE); unset($HTMLTABLE, $search, $__SQL);
				$view 	->	assign('FOCUS', 'NEW');
				$view 	->	assign('SELF', backward());
				$view	->	display();
				exit;
			}

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get('nothingtosearch'));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}	

	# display the form

	$view	=	new View('timingsearch');
	
	$view 	->	cache($_GET['cat']);
	
	$view	->	assign('LABEL', $__LANG->get('productionordertiming'));

	$DATENAMES	=	array('date_of_creation', 'date_of_deadline', 'date_of_finishing');

	$DATENAMES_R	=	array();

	foreach ($DATENAMES as $NAME) array_push($DATENAMES_R, $__LANG->get($NAME));

	$view	->	assign('COUNT', count($DATENAMES));
	$view	->	assign('DATENAMES', $DATENAMES); unset($DATENAMES);
	$view	->	assign('DATENAMES_R', $DATENAMES_R); unset($DATENAMES_R);

	$TYPES		=	array('day', 'month', 'year');

	$view	->	assign('TYPE', $TYPES); unset($TYPES);

	$TYPENAMES	=	array($__LANG->get('day'), $__LANG->get('month'), $__LANG->get('year'));

	$view	->	assign('TYPENAME', $TYPENAMES); unset($TYPENAMES);

	$ELEMENTS	=	array('=', '!=', '&lt;', '&gt;');

	$view	->	assign('ELEMENTS', $ELEMENTS); unset($ELEMENTS);

	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=production');
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('SEARCH', $__LANG->get('search'));

	$view	->	display();

?>


