<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag production order change
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('production');

	pagepermission('production', 'w');

	if (isset($_GET['id']))		{

		$PRODUCTIONORDERID = $_SESSION['ID'] = $_GET['id'];
		
	}	else	  {

		$PRODUCTIONORDERID = $_SESSION['ID'];
	}
	
	if ((! isset($_GET['p_err'])) && isset($_SESSION['_POST_ERR'])) unset($_SESSION['_POST_ERR']);

	load_c('SQL');

	$__SQL	=  new SQL;

	if (isset($_POST['submit']))	{
	
		unset($_POST['submit']);
	
		# first check the orders type
		
		load_m('isproduction2stock');
		
		$__CHECK = new IS_PRODUCTION_TO_STOCK();
		
		$stockproduction = $__CHECK->check($PRODUCTIONORDERID);
		
		unset($__CHECK);
		
		if ($stockproduction)	{
		
			# production to stock
		
			load_m('productionorder2stockupdate');

      			$__PRODUCTIONORDER	=	new PRODUCTIONORDER2STOCKUPDATE();

			$RESULT			=	$__PRODUCTIONORDER->update($PRODUCTIONORDERID, $_POST);

			$ORDER2STOCK		=	$__PRODUCTIONORDER->ORDER_TO_STOCK;
		
		}	else	 {
		  
			# production to customers

			load_m('productionorderupdate');

			$__PRODUCTIONORDER	=	new PRODUCTIONORDERUPDATE();

			$RESULT			=	$__PRODUCTIONORDER->update($PRODUCTIONORDERID, $_POST);

			$ORDER2STOCK		=	$__PRODUCTIONORDER->ORDER_TO_STOCK;
		}

		unset($__SQL, $__PRODUCTIONORDER);

		if ($RESULT !== TRUE)	{
		
			$_POST['_err_address'] = backward();

			$_SESSION['_POST_ERR']	=  	$_POST;

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_POST['_err_address']."&amp;id=$PRODUCTIONORDERID&amp;p_err=1");
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		if ($ORDER2STOCK)	{

			header("location: loader.php?cat=order2stock_from_production&change=true&id=$PRODUCTIONORDERID");
			exit;
		}

		header("location: loader.php?cat=productionorderupdated&id=$PRODUCTIONORDERID");

		exit;
	}

	# read order data

	if (post_data_verified())	{

		$_POST = enc_quotes($_SESSION['_POST_ERR']);

		unset($_SESSION['_POST_ERR']);

	}	else	  {

		load_m('productionorderread');

		$__PRODUCTIONORDER	=	new	PRODUCTIONORDERREAD();
		$_POST			=	$__PRODUCTIONORDER->read($PRODUCTIONORDERID);

		unset($__PRODUCTIONORDER);

		if ($_POST===FALSE)		{

			$view	=	new View('errorbox');
			$view	->	assign('SELF',  $_SESSION['FROM']);
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get('unexistentproductionorder'));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}
	}

	$view	=	new View('productionorder');

	$view	->	assign('SELF', backward());
	$view	->	assign('PRODUCTION_ORDER_LABEL', $__LANG->get('productionorderchange', $PRODUCTIONORDERID.'/'.$_POST['productionorder_year']));
	$view	->	assign('PRODUCTIONORDERID', $PRODUCTIONORDERID);
	$view	->	assign('CODE', $__LANG->get('code'));
	$view	->	assign('ARTICALNAME', $__LANG->get('articalname'));
	$view	->	assign('CONNECTED_WITH_ORDER', $__LANG->get('connectedwithorder'));
	$view	->	assign('QUANTITY', $__LANG->get('quantity'));
	$view	->	assign('CUSTOMER', $__LANG->get('customer'));
	$view	->	assign('DATE_OF_CREATION', $__LANG->get('date_of_creation'));
	$view	->	assign('DATE_OF_DEADLINE', $__LANG->get('date_of_deadline'));
	$view	->	assign('TECHNOLOGY', $__LANG->get('technology'));
	$view	->	assign('DRAWING_NUMBER', $__LANG->get('drawingnumber'));
	$view	->	assign('COLUMNCODE', $__LANG->get('columnname_code'));
	$view	->	assign('COLUMNNAME', $__LANG->get('columnname_name'));
	$view	->	assign('COLUMNQUANTITY', $__LANG->get('columnname_quantity'));
	$view	->	assign('COLUMNUNIT', $__LANG->get('columnname_unit'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('SEARCH', $__LANG->get('search'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('BACKTO', $_SESSION['FROM']);
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	
	unset($__SQL);

	$view	->	display();

?>
