<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag create new salary	
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('salarys');

	pagepermission('salarys', 'w');

	load_c('SQL');

	$__SQL	= new SQL();

	if (isset($_POST['submit']))	{

		load_m('newsalary');

		$__SALARY = new NEWSALARY();

		# note: posted zero is for all

		if ($_POST['employeeID']>0) $__SALARY -> employeeID($_POST['employeeID']);

		if ((isset($_POST['delete_previous'])) && ($_POST['delete_previous']))  $__SALARY -> deleteprevious();

		if ((isset($_POST['month'])) && ($_POST['month'])) $__SALARY -> month($_POST['month']);
		
		if ((isset($_POST['semimonth'])) && ($_POST['semimonth'])) $__SALARY -> semimonth($_POST['semimonth']);

		$RESULT = $__SALARY->create();
		
		$REPORT_MSG = $__SALARY->report_msg;
		
		unset($__SALARY, $__SQL);
		
		$view	=	new View('salarycreated');

		if ($RESULT !== TRUE)	{

			$view	->	assign('LABEL', $__LANG->get('salaryfailed'));
			
		}	else	  {
		
			$view	->	assign('LABEL', $__LANG->get('salarycreated'));
		}
		
		if ((isset($_POST['month'])) && ($_POST['month']))	{
		
			$period = $__LANG->get('monthname'.$_POST['month']);
			  
		}	else	  {
			
			if ($_POST['semimonth'] % 2)	{
			
				$period = $__LANG->get('monthname'.((integer)(($_POST['semimonth']/2)+1))).' I';
				
			}	else	  {
			
				$period = $__LANG->get('monthname'.($_POST['semimonth']/2)).' II';
			}
		}
		
		$view	->	assign('SELF', backward());
		$view	->	assign('PAYROLL_PERIOD', $__LANG->get('payrollperiod'));
		$view	->	assign('PERIOD', $period);
		$view	->	assign('REPORT', $__LANG->get('report'));
		$view	->	assign('REPORT_MSG', $REPORT_MSG);
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', backward());
		$view	->	display();
		exit;
	}

	# read employees to form

	load_m('employeesread');

	$__EMPLOYEES	=	new EMPLOYEESREAD();

	$EMPLOYEES	=	$__EMPLOYEES->read();

	unset($__EMPLOYEES);

	if (! $EMPLOYEES)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', 'loader.php?cat=section&amp;id=salarys');
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('noemployees'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}
	
	# display the form

	$view	=	new View('newsalary');

	$view	->	assign('SELF', backward());
	$view	->	assign('NEW_SALARY', $__LANG->get('newsalary'));
	$view	->	assign('DELETE_PREVIOUS', $__LANG->get('deleteprevioussalary'));
	$view	->	assign('MONTHLY', $__LANG->get('calculate_monthly'));
	$view	->	assign('SEMI_MONTHLY', $__LANG->get('calculate_semimonthly'));
	$view	->	assign('EMPLOYEE', $__LANG->get('employee')); 
	
	# add to first place in array option 0=>all
		
	$EMPLOYEES = array(0=>$__LANG->get('all')) + $EMPLOYEES;

	$view	->	assign('EMPLOYEES', $EMPLOYEES); unset($EMPLOYEES);
	
	# note: monthly 1-12, semi-monthly 1-24
	
	$MONTHS = $MONTH_PARTS = array();
	
	for ($i=1; $i<=12; $i++)	{
	
		# months
	
		$MONTHS[$i] = $__LANG->get("monthname$i");
	
		# semi-months
		
		$j = $i*2;
		
		$MONTH_PARTS[$j-1] = $MONTHS[$i].'&nbsp;&nbsp;&nbsp;I';

		$MONTH_PARTS[$j]   = $MONTHS[$i].'&nbsp;&nbsp;II';
	}

	$view	->	assign('MONTHNAMES', $MONTHS); unset($MONTHS);
	$view	->	assign('MONTH_PART_NAMES', $MONTH_PARTS); unset($MONTH_PARTS);
	
	$view	->	assign('OK', $__LANG->get('ok'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=salarys');

	unset($__SQL);
	
	$view	->	display();

?>

