<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag working hours delete to employee
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}
	
	check_year_for_write('employees');

	pagepermission('employees', 'w');

	load_c('SQL');

	$__SQL	= new SQL();

	if (isset($_POST['submit']))	{

		# note: js will collect the IDs in hidden input 'selecteditems'

		load_m('workinghoursdelete');

		$__HOURS	=	new WORKINGHOURSDELETE();

		$RESULT		=	$__HOURS->delete($_POST['selecteditems'], $_POST['date']);

		unset($__HOURS, $__SQL);

		if ($RESULT !== TRUE)	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('alertbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('hoursdeleted'));
		$view	->	assign('NEW', $__LANG->get('new'));
		$view	->	assign('CANCEL', $__LANG->get('cancel'));
		$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=employees');
		$view	->	display();
		exit;
	}

	load_m('employeesread');

	$__EMPLOYEES	=	new EMPLOYEESREAD();

	$EMPLOYEESDATA	=	$__EMPLOYEES->read();

	unset($__EMPLOYES, $__SQL);

	if (! $EMPLOYEESDATA)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', 'loader.php?cat=section&amp;id=employees');
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('noemployees'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	$view	=	new View('delete_working_hours');

	$view	->	assign('SELF', backward());
	$view	->	assign('DELETE_WORKING_HOURS', $__LANG->get('deleteworkinghours'));
	$view	->	assign('EMPLOYEE_NAME', $__LANG->get('employeename'));
	$view	->	assign('DATE', $__LANG->get('date'));
	$view	->	assign('SELECTED', $__LANG->get('selected'));
	$view	->	assign('DELETE', $__LANG->get('delete'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=employees');
	$view	->	assign('EMPLOYEES', $EMPLOYEESDATA); unset($EMPLOYEESDATA);

	$view	->	display();
?>
