	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */
	
	/**	
	 * eBag handles command line form
	 */

	function addcolumn(field)	{

		var selected = field.value;

		if (selected) document.forms[0].command.value += ' `' + selected +'` ';
	}
	
	function changebase(field)	{
	  
		var show, hide;

		var selected = field.value;

		if (selected)	{
		  
			 document.forms[0].command.value += ' ' + selected + '.';
			 
			 if (selected == 'ebagstock')	{show = 'stockspan'; hide = 'dataspan';} else {show = 'dataspan'; hide = 'stockspan';}
			   
			 document.getElementById(show).className = 'select-show';
			 document.getElementById(hide).className = 'select-hide';
			 
			 changetable();
		}
	}
	
	function setColumns(rows, removeonly)	{
	  
		var i;

		var field	=	document.getElementById('columns');

		var count	=	field.options.length;

		for(i=count-1; i>=0; i--) field.options.remove(i);

		var optn	=	document.createElement("OPTION");
		optn.text 	=	'<------->';
		optn.value	=	'';
		optn.selected	=	true;

		field.options.add(optn);
		
		if (removeonly) return;
		
		count = rows.length;

		for(i=0; i<count; i++) 	{

			optn		=	document.createElement("OPTION");
			optn.text 	=	rows[i];
			optn.value	=	rows[i];

			field.options.add(optn);
		}
	}
	
	function delColumns()	{
	  
		setColumns(true, true);
	}
	
	function changetable()	{
	  
		var show, hide, selectId;
		
		var xmlHttp = createXmlHttpRequestObject();

			xmlHttp.onreadystatechange=function()	{

			if (xmlHttp.readyState==4 && xmlHttp.status==200)	{

				if (xmlHttp.responseText)	{

					  setColumns(xmlHttp.responseText.split(';'), false);
					  
					  document.forms[0].command.value += table;
				}
	    		}
	  	}
	  	
	  	var base = document.getElementById('bases').value;

		if (document.getElementById('dataspan').className == 'select-show') {selectId = 'datatables';} else {selectId = 'stocktables';}
	
		var table = document.getElementById(selectId).value;
		
		if (! table) {delColumns(); return;}
		
		xmlHttp.open('GET', '../requests/tablecolumns.php?base=' + encodeURIComponent(base) + '&table=' + encodeURIComponent(table) + '&nc=' + (new Date().getTime()).toString(), true);

		xmlHttp.send();
	}


