	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag summary calculations window
	 */

	function summ(direction)	{

		var form = document.forms[0];

		// read discounts

		var SESSION_D	=	0;
		var ARTICLE_D	=	0;
		var SERVICE_D	=	0;
		var EXCHANGE_Q	=	0;

		if ((form.use_session_discount != null) && (form.use_session_discount.checked == true))	SESSION_D = Number(form.session_discount.value);

		if ((form.use_article_discount != null) && (form.use_article_discount.checked == true))	ARTICLE_D = Number(form.article_discount.value);

		if ((form.use_service_discount != null) && (form.use_service_discount.checked == true))	SERVICE_D = Number(form.service_discount.value);

		// read currency, tax, form_in_valuta

		var READTYPES	=	false;

		if (SERVICE_D && ARTICLE_D) READTYPES = true;
	
		var EXCHANGE_RATE	=	Number(form.exchange_rate.value);
		var CURRENCY		=	form.currency.value;
		var VALUTA		=	form.valuta.value;
		
		var PAYMENT;

		if ((form.offer_in_valuta != null) && (form.offer_in_valuta.checked == true))	{

			PAYMENT		=	VALUTA;

		}	else	  {

			PAYMENT		=	CURRENCY;
		}

		// read articles by rowid

		var CODE	= [];
		var NAME	= [];
		var QUANTITY	= [];
		var UNIT	= [];
		var PRICE	= [];
		var PRICEALL	= [];
		var TAX 	= [];
		var PRICEALL_NOTAX = [];
	
		if (READTYPES)	var TYPE = [];

		var divs	=	document.getElementsByTagName("div");
		var count	=	divs.length;
		var j		=	0;
		var SUM		=	0;
		var SUM_NOTAX	=	0;
		var CODE_t, NAME_t, QUANTITY_t, UNIT_t, PRICE_t, TAX_t, i;

		if (! count) return;
		
		for(i=0; i<count; i++)	{

			if (divs[i].id.indexOf('rowid_') != -1)	{

				elements	=	divs[i].id.split('_');		
				rowid		=	elements[1];

				CODE_t		=	form['code_' + rowid ].value;
				NAME_t		=	form['name_' + rowid ].value;
				QUANTITY_t	=	Number(form['quantity_' + rowid ].value);
				UNIT_t		=	form['unit_' + rowid ].value;
				PRICE_t		=	Number(form['price_' + rowid ].value);
				TAX_t		=	Number(form['tax_' + rowid ].value);
				
				// Note: tax can be 0

				if ((CODE_t == '') || (NAME_t == '') || (QUANTITY_t == 0) || (UNIT_t =='') || (PRICE_t == 0)) continue;

				CODE[j]		=	CODE_t;
				NAME[j]		=	NAME_t;
				QUANTITY[j]	=	QUANTITY_t;
				UNIT[j]		=	UNIT_t;
				PRICE[j]	=	PRICE_t;
				TAX[j]		=	TAX_t;

				if (READTYPES) TYPE = form['type_' + rowid ].value;
	
				if (PRICE[j]>0)		{

					if (READTYPES)		{

						if (TYPE == 's') PRICE[j] = PRICE[j] * (100-SERVICE_D)/100;
						if (TYPE == 'a') PRICE[j] = PRICE[j] * (100-ARTICLE_D)/100;

					}	else	 {

						// note: one of them will be 1

						PRICE[j] = PRICE[j] * (100-SERVICE_D) * (100-ARTICLE_D)/10000;
					}

					PRICE[j] = PRICE[j] * (100-SESSION_D)/100;

					if (PAYMENT != VALUTA) PRICE[j] = PRICE[j] * EXCHANGE_RATE;
					
					if (QUANTITY[j]<=0) QUANTITY[j] = 0;
					  
					PRICEALL_NOTAX[j] = PRICE[j] * QUANTITY[j];
					
					PRICEALL[j] = PRICEALL_NOTAX[j] * ((100 + TAX[j])/100);
					
					SUM_NOTAX += PRICEALL_NOTAX[j];

					SUM += PRICEALL[j];

					PRICE[j] 	=	round2(PRICE[j]);
					PRICEALL[j]	=	round2(PRICEALL[j]);
				}
	
				j++;
			}
		}

		count = CODE.length;

		if (! count) return;

		// read column names

		var CODETXT	= document.getElementById('columncode').innerHTML;
		var NAMETXT	= document.getElementById('columnname').innerHTML;
		var QUANTITYTXT	= document.getElementById('columnquantity').innerHTML;
		var UNITTXT	= document.getElementById('columnunit').innerHTML;
		var PRICETXT	= document.getElementById('columnprice').value;
		var TAXTXT	= document.getElementById('columntax').value;

		// write out
		
		var html_style = '';
		var a_left  = 'left';
		var a_right = 'right';
		
		if (direction == 'rtl') {html_style = 'html {direction : rtl;}'; a_left  = 'right'; a_right = 'left';}

		var 	html='<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">\n';

		html +='<html><head><META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8"><title>eBag</title>\n';
		html +='<style type="text/css">' + html_style + ' body {background	: #E5E5E5; white-space: nowrap;} .sum {border-collapse: collapse; background: #BBBBBB; color: #374A57;  font-family: Verdana, Arial, Helvetica;  font-size: 11px; text-decoration: none; text-indent:0pt;} .sum td {padding: 5px; border: 1px dotted #7B8C8A;}</style>\n';
		html +='</head><body bgcolor="#E5E5E5">\n';

		html +='<center><br><table id="sumt" class="sum" cellpadding="2px" cellspacing="0px">\n';

		html +='<tr align="' + a_left + '" valign="bottom"><td>' + CODETXT + '</td><td>' + NAMETXT + '</td><td>' + QUANTITYTXT + '</td><td>' + UNITTXT + '</td><td>' + PRICETXT + '</td><td>&Sigma;</td><td>' + TAXTXT + '</td><td align="center">&Sigma; + ' + TAXTXT + '</td></tr>\n';


		for(i=0; i<count; i++)	{

			html += '<tr><td>' + CODE[i] + '</td><td>' + NAME[i] + '</td><td>' + QUANTITY[i] + '</td><td>' + UNIT[i] + '</td><td>' + round2(PRICE[i]) + '</td><td>' + round2(PRICEALL_NOTAX[i]) +'</td><td>' + TAX[i] + '%</td><td align="' + a_right + '">' + round2(PRICEALL[i]) + '</td></tr>\n';
		}

		html +='<tr><td colspan="7" align="' + a_left + '">&Sigma; - ' + TAXTXT + '</td><td align="' + a_right + '">' + round2(SUM_NOTAX) + ' ' + PAYMENT + '</td></tr>\n';
		html +='<tr><td colspan="7" align="' + a_left + '">&Sigma; + ' + TAXTXT + '</td><td align="' + a_right + '">' + round2(SUM) + ' ' + PAYMENT +'</td></tr>\n';


		if (SESSION_D > 0)	html +='<tr><td colspan="7" align="' + a_right + '">' + form.used_session_discount.value + '</td><td align="' + a_right + '">' + SESSION_D +' %</td></tr>\n';
		if (ARTICLE_D > 0)	html +='<tr><td colspan="7" align="' + a_right + '">' + form.used_article_discount.value + '</td><td align="' + a_right + '">' + ARTICLE_D +' %</td></tr>\n';
		if (SERVICE_D > 0)	html +='<tr><td colspan="7" align="' + a_right + '">' + form.used_service_discount.value + '</td><td align="' + a_right + '">' + SERVICE_D +' %</td></tr>\n';

		html += '</table>';

		try {summary_win.close();} catch (error) {}

		var left  = (screen.width  - 500)/2;
		var top   = (screen.height  - 300)/2;

		summary_win = window.open('', '', 'height=300, width=500, top=' + top + ', left=' + left + ', status=No, scrollbars=yes');

		summary_win.document.writeln(html);
		
		// correct the width by need
		
		try	{
		
			var windowWidth = summary_win.document.getElementById("sumt").offsetWidth + 60;

			if (windowWidth > 500) summary_win.resizeTo(windowWidth, 300);
			
			summary_win.focus();
		}
		catch (error) {}
	}

	function round2(n) {
	
		return Math.round(n*100)/100;
	}
