<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag stock write
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	load_f('addtax');

	load_f('is_real_positive');
	
	load_f('is_real_tax');
	
	load_f('is_longer');

	class ARTICALWRITE 	{

		function __construct()	{

			global $__SQL, $__CONF;

			$this->SQL		=	&$__SQL;

			$this->CONF		=	&$__CONF;

			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';
		}

		private function prepare($DATA)	 {

			# Check user input

			if ((is_empty($DATA['articalname'])) or 
			    (is_empty($DATA['code'])) or
			    (is_longer($DATA['code'], 25)) or
			    (is_empty($DATA['unit'])) or
			    (is_empty($DATA['price'])) or
			    (is_empty($DATA['dimensions'])) or
			    (is_empty($DATA['tax']))) return FALSE;

			if ((! is_real_positive($DATA['price'])) or 
			    (! is_real_tax($DATA['tax'])) or
			    ((! is_empty($DATA['purchase_price'])) && ((! is_numeric($DATA['purchase_price'])) or ($DATA['purchase_price'] < 0)))) return FALSE;
			    
			# Change empty purchase_price to zero
			
			if (is_empty($DATA['purchase_price'])) $DATA['purchase_price'] = 0;

			# Escape the data

			foreach ($DATA as $key=>$val) $DATA[$key] = $this->SQL->n_escape($val);

			return $DATA;			
		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES 	$this->BASE.addressbook WRITE, 
							$this->STOCKBASE.finished_goods_stock WRITE	");
		}
		
		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function write($DATA)	{

			if (! $DATA = $this->prepare($DATA)) return 'usererror';

			$this->lock();

			extract($DATA); unset($DATA);

			# if is not product check supplier, origin1=>product

			if (str_replace("'", '', $origin) != 1)	{

				$this->SQL->query("	SELECT `city` 
							FROM $this->BASE.addressbook 
							WHERE `personID`=$supplierID AND `contactname`=$supplier AND `deleted` IS NOT NULL LIMIT 1	");

				if (! $this->SQL->num_rows())	{

					$this->unlock();
					return 'suppliernotmatch';
				}
			}	 else		{

				# if is product set supplier to company production

				$supplierID	=	"'0'";
				$supplier	=	"'Production'";
			}

			# check artical exists

			$this->SQL->query("	SELECT `personID` 
						FROM $this->STOCKBASE.finished_goods_stock 
						WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$this->unlock();
				return 'articalexists';
			}

			$price_with_tax =	addtax(str_replace("'", '', $price), str_replace("'", '', $tax));

			$COMMAND	=	"INSERT INTO $this->STOCKBASE.finished_goods_stock VALUES (	NULL, $code, $articalname, $dimensions, $unit,
														'0', '0', '0', '0', '0', '0', $price, $tax, '$price_with_tax',
														$purchase_price, $origin, $supplier, $supplierID,
														$comment, '0'	)";

			$this->SQL->query($COMMAND);

			$this->unlock();

			return TRUE;
		}

		public function copy($DATA)	{

			$RESULT	= $this->write($DATA);
		
			return $RESULT;
		}
	}
?>
