<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag bill read
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class BILLREAD	{

		function __construct()	{

			global $__SQL, $__CONF;

			$this->SQL	=	&$__SQL;

			$this->BASE	=	$_SESSION['BASE'];

			$this->FORMAT	=	$__CONF->get('date', 'sql_format');
			
			$this->APC	=	$__CONF->get('cache', 'use_apc_cache');
		}

		private function lock()		{

			$this->SQL->query("	LOCK TABLES	$this->BASE.bills_header WRITE, $this->BASE.bills_data WRITE, 
								$this->BASE.services_data WRITE, $this->BASE.deliverys_data WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function createlist($STRING)	{

			if (! $STRING) return '';

			$LIST	=	explode('-', $STRING);

			unset($LIST[count($LIST)-1], $LIST[0]);

			return implode(',', $LIST);
		}

		public function read($ID)	{

			$ID	=	$this->SQL->escape($ID);

			$DATA	=	FALSE;
			
			# read payment
			
			$__PAYMENTS	= new PAYMENTloader($this->APC);

			$PAYMENT_FORMS	= $__PAYMENTS->getnames();
			
			unset($__PAYMENTS);

			# read

			$this->lock();

			# read header data

			$this->SQL->query("	SELECT	`contactname`, `country`, `city`, `zip`, `street`, `payment_form`, 
							`connected_with_deliverys`, `connected_with_reverses`, `comment`, `annotation`, 
							DATE_FORMAT(`date_of_creation`, '$this->FORMAT') AS `date_of_creation`,
							DATE_FORMAT(`payment_deadline`, '$this->FORMAT') AS `payment_deadline`,
							`comment`, `annotation`
						FROM $this->BASE.bills_header 
						WHERE personID='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$DATA	=	$this->SQL->RESULT->fetch_assoc();

				$DATA['connected_with_reverses']	=	$this->createlist($DATA['connected_with_reverses']);

				$DATA['connected_with_deliverys']	=	$this->createlist($DATA['connected_with_deliverys']);


				if (isset($PAYMENT_FORMS[$DATA['payment_form']])) $DATA['payment_form'] = $PAYMENT_FORMS[$DATA['payment_form']];

				unset($PAYMENT_FORMS);

				# read service lists and deliverys separatelly

				$this->SQL->query("	SELECT `deliveryID` 
							FROM $this->BASE.deliverys_data
		 				 	WHERE 	`personID` IN (	SELECT `dataID` 
										FROM $this->BASE.bills_data
										WHERE `billID`='$ID' AND `datatype`='d' AND `deleted` IS NOT NULL	)
		  						AND `deleted` IS NOT NULL GROUP BY `deliveryID`	");

				$DATA['deliverys']	=	array();

				$DATA['reverses']	=	array();

				if ($this->SQL->num_rows())	{

					$this->SQL->IT1_RESULT = $this->SQL->RESULT;

					while ($RESULT = $this->SQL->IT1_RESULT->fetch_row())	{

						$deliveryID	=	$RESULT[0];

						$this->SQL->query("	SELECT `code`, `name`, `quantity`, `unit`, `price`, `dataID`
									FROM $this->BASE.bills_data
									WHERE 	`billID`='$ID' AND `dataID` IN (SELECT `personID` 
														FROM $this->BASE.deliverys_data
														WHERE `deliveryID`='$deliveryID' AND `deleted` IS NOT NULL)
										AND `datatype`='d'
										AND `deleted` IS NOT NULL ORDER BY `personID`	");

						if ($this->SQL->num_rows())	{
						
							$DATA['deliverys'][$deliveryID] = array();
							
							while ($RESULT_N = $this->SQL->RESULT->fetch_assoc()) $DATA['deliverys'][$deliveryID][] = $RESULT_N;
						}
					}

					unset($this->SQL->IT1_RESULT);
				}

				$this->SQL->query("	SELECT `reversID` 
							FROM $this->BASE.services_data
							WHERE 	`personID` IN (	SELECT `dataID` 
										FROM $this->BASE.bills_data 
										WHERE `billID`='$ID' AND `datatype`='s' AND `deleted` IS NOT NULL)
				  				AND `deleted` IS NOT NULL GROUP BY `reversID`	");

				if ($this->SQL->num_rows())	{

					$this->SQL->IT1_RESULT = $this->SQL->RESULT;

					while ($RESULT = $this->SQL->IT1_RESULT->fetch_row())	{

						$reversID	=	$RESULT[0];

						$this->SQL->query("	SELECT `code`, `name`, `quantity`, `unit`, `price`, `dataID`
									FROM $this->BASE.bills_data
									WHERE 	`billID`='$ID' AND `dataID` IN (SELECT `personID`
														FROM $this->BASE.services_data
														WHERE `reversID`='$reversID' AND `deleted` IS NOT NULL)
										AND `datatype`='s'
										AND `deleted` IS NOT NULL ORDER BY `personID`	");

						if ($this->SQL->num_rows())	{

							$DATA['reverses'][$reversID] = array();
							
							while ($RESULT_N = $this->SQL->RESULT->fetch_assoc()) $DATA['reverses'][$reversID][] = $RESULT_N;
						}
					}

					unset($this->SQL->IT1_RESULT);
				}

				if (! count($DATA['deliverys']))	$DATA['deliverys']	=	FALSE;
				if (! count($DATA['reverses']))		$DATA['reverses']	=	FALSE;

				if ((! $DATA['deliverys']) && (! $DATA['reverses'])) $DATA = FALSE;
			}

			$this->unlock();

			return $DATA;
		}
	}
?>
