<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag contact change
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}
	
	load_f('is_longer');

	class CONTACTCHANGE extends CONTACTREAD	{

		/**
		 * Contact change
		 */

		public function change($ID, $DATA)	{

			# Check user input	
			
			$err = FALSE;

			if (isset($DATA['delivery']))	{

				if ((is_empty($DATA['delivery_city'])) or (is_empty($DATA['delivery_street'])) or (is_empty($DATA['delivery_zip']))) $err='usererror';
			}

			if ((is_empty($DATA['contactname'])) or (is_longer($DATA['contactname'], 40)) or (is_empty($DATA['city'])) or (is_empty($DATA['street']))) $err='usererror';

			if ($err) return $err;

			# Fill the eventual unset elements

			$disableds	=	array('delivery_country', 'delivery_city', 'delivery_street', 'delivery_zip', 'delivery_day_of_week');

			foreach ($disableds as $disabled) {if (! isset($DATA[$disabled])) $DATA[$disabled]='';}

			unset($disableds);

			# Escape the data

			$ID	=	$this->SQL->escape($ID);

			$this->SQL->query("LOCK TABLES $this->BASE.addressbook WRITE");

			foreach ($DATA as $key=>$val)	$DATA[$key] = $this->SQL->n_escape($val);

			extract($DATA); unset($DATA);

			# Check the contact is not deleted in meantime

			$this->SQL->query("	SELECT `contactname` 
						FROM $this->BASE.addressbook 
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->query('UNLOCK TABLES');

				return 'contactdeleted';
			}

			# Check the changed name in this city maybe exists one time

			$this->SQL->query("	SELECT `street` 
						FROM $this->BASE.addressbook 
						WHERE `personID`!='$ID' AND `contactname`=$contactname AND `city`=$city AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$this->SQL->query('UNLOCK TABLES');

				return 'contactexists';
			}

			# Update

			$COMMAND	="	UPDATE	$this->BASE.addressbook	SET  

							`contactname`=$contactname, `contactperson`=$contactperson, `country`=$country, `city`=$city, `zip`=$zip, `street`=$street,
							`telephone1`=$telephone1, `telephone2`=$telephone2, `fax`=$fax, `mobilephone`=$mobilephone, `mail`=$mail, `website`=$website,
							`contacttype`=$contacttype, `delivery_country`=$delivery_country, `delivery_city`=$delivery_city, `delivery_street`=$delivery_street,
							`delivery_zip`=$delivery_zip, `delivery_day_of_week`=$delivery_day_of_week, `account1`=$account1, `bank1`=$bank1, 
							`account2`=$account2, `bank2`=$bank2, `tax_id_number`=$tax_id_number

						WHERE `personID`='$ID' LIMIT 1";

			$this->SQL->query($COMMAND);

			$this->SQL->query('UNLOCK TABLES');

			return TRUE;
		}
	}


?>
