<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag contact delete
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class CONTACTDELETE	{

		function __construct()	{

			global $__SQL;

			$this->SQL	=	&$__SQL;

			$this->BASE	=	$_SESSION['BASE'];
		}

		private function lock()	{

			$this->SQL->query("	LOCK TABLES 	$this->BASE.addressbook WRITE, 
								$this->BASE.services_header WRITE, 
								$this->BASE.offers_header WRITE, 
								$this->BASE.orders_header WRITE, 
								$this->BASE.production_orders_phases WRITE, 
								$this->BASE.claims WRITE,
								$this->BASE.customers_payments WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}


		public function delete($ID)	{

			# no need to transaction, the tables are locked
			# because of checks, only one write is in commands

			$ID	=	$this->SQL->escape($ID);

			$this->lock();

			# verify that something is crated connected with this contact

			$this->SQL->query("	(
							SELECT `personID` 
							FROM $this->BASE.services_header
							WHERE `contactID`='$ID' AND `deleted` IS NOT NULL LIMIT 1
						)
			  			UNION ALL
			  			(
							SELECT `personID` 
							FROM $this->BASE.offers_header
							WHERE `contactID`='$ID' AND `deleted` IS NOT NULL LIMIT 1
						)
			  			UNION ALL
			  			(
							SELECT `personID` 
							FROM $this->BASE.orders_header
							WHERE `contactID`='$ID' AND `deleted` IS NOT NULL LIMIT 1
						)
						UNION ALL
						(
							SELECT `personID` 
							FROM $this->BASE.claims
							WHERE `contactID`='$ID' AND `deleted` IS NOT NULL LIMIT 1
						)
						UNION ALL
			 			(
							SELECT `personID` 
							FROM $this->BASE.customers_payments
							WHERE `contactID`='$ID' AND `deleted` IS NOT NULL LIMIT 1
						)	");

			if ($this->SQL->num_rows())	{

				$this->unlock();

				return 'cantdeleteusedcustomer';
			}

			# it this contact is cooperatot verify the production orders

			$this->SQL->query("	SELECT `contacttype`
						FROM $this->BASE.addressbook
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL  ");

			if (! $this->SQL->num_rows())	{

				$this->unlock();

				return 'alreadydeleted';
			}

			$RESULT = $this->SQL->RESULT->fetch_row();

			# note: contacttype 4 => cooperator

			if ($RESULT[0] == 4)	{

				# note: phases are deleted permanently

				$this->SQL->query("	(
								SELECT `personID` 
								FROM $this->BASE.services_header 
								WHERE `finisher`='cooperator_$ID' AND `deleted` IS NOT NULL LIMIT 1
							)
				  			UNION ALL
				  			(
								SELECT `personID` 
								FROM $this->BASE.production_orders_phases
								WHERE `finisher`='cooperator_$ID' LIMIT 1
							)"	);

				if ($this->SQL->num_rows())	{

					$this->unlock();

					return'cantdeleteusedcooperator';
				}

			}

			$this->SQL->query("	UPDATE $this->BASE.addressbook 
						SET `deleted`=NULL 
						WHERE `personID`='$ID' LIMIT 1	");

			$this->unlock();

			return TRUE;
		}
	}

?>
