<?php

	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag define current discount
	 */
	 
	 class CURRENTDISCOUNT	{
	 
		function __construct()	{
		
			global $__SQL, $__SESS;

			$this->SQL = &$__SQL;
			
			$this->SESS = &$__SESS;
		}

		private function loggeds_count()	{

			$COUNT = 0;

			$this->SQL->query("	SELECT `personID`
						FROM ebag.users
						WHERE `deleted` IS NOT NULL	");

			while ($RESULT = $this->SQL->RESULT->fetch_row())	{

				if ($this->SESS->is_logged($this->SQL->r_escape($RESULT[0]))) $COUNT++;
			}

			return $COUNT;
		}
		
		function change($discount)	{
		
			if ((! is_numeric($discount)) or ($discount < 0) or ($discount >= 100)) return 'usererror';
			
			if ($this->loggeds_count() > 1) return 'discounterror';
			
			$discount = $session_discount = round($discount, 2);	
			
			# to not show 0.00
			
			if (! $discount) { $discount = $session_discount = '0'; }
			
			$discount = $this->SQL->n_escape($discount);
			
			# change
			
			$this->SQL->query("	UPDATE ebag.settings 
						SET value=$discount
						WHERE `key`='discount'	");
	
			# change session to

			$_SESSION['discount'] = $session_discount;
			
			return TRUE;
		}
	 }
	 

?>