<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag employee delete
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class EMPLOYEEDELETE	{

		function __construct()	{

			global $__SQL;
	
			$this->SQL	=	&$__SQL;

			$this->BASE	=	$_SESSION['BASE'];
		}

		private function lock()	{

			$this->SQL->query("	LOCK TABLES 	$this->BASE.employees WRITE, 
								$this->BASE.services_header WRITE, 
								$this->BASE.production_orders_phases WRITE, 
								$this->BASE.working_hours WRITE,
								$this->BASE.employees_items_bonuses WRITE,
								$this->BASE.employees_phases_bonuses WRITE,
								$this->BASE.salarys_personal_data WRITE,
								$this->BASE.salarys WRITE 	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}
		
		private function rollback()	{
		
			$this->SQL->rollback();	

			$this->unlock();
		}

		public function delete($ID)	{

			$ID	=	$this->SQL->escape($ID);
			
			$this->SQL->transaction();

			$this->lock();

			# chek for finished service or production phase

			$this->SQL->query("	(
							SELECT `personID` 
							FROM $this->BASE.services_header 
							WHERE `finisher`='employee_$ID' AND `deleted` IS NOT NULL LIMIT 1
						)
			  			UNION ALL
						(
							SELECT `personID` 
							FROM $this->BASE.production_orders_phases
							WHERE `finisher`='employee_$ID' LIMIT 1
						)	");

			if ($this->SQL->num_rows())	{
			
				$this->rollback();

				return 'employeedelwithrevers';
			}

			# check for working hours

			$this->SQL->query("	SELECT `personID` 
						FROM $this->BASE.working_hours 
						WHERE `employeeID`='$ID' LIMIT 1	");

			if ($this->SQL->num_rows())	{
			
				$this->rollback();

				return 'employeedelwithhours';
			}
			
			# check for salary

			$this->SQL->query("	SELECT `personID` 
						FROM $this->BASE.salarys
						WHERE `employeeID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{
			
				$this->rollback();

				return 'employeedelwithsalary';
			}			
			
			# delete

			$this->SQL->query("	UPDATE $this->BASE.employees
						SET `deleted`=NULL 
						WHERE `personID`='$ID' LIMIT 1	");
						
			$this->SQL->query("	UPDATE $this->BASE.employees_items_bonuses
						SET `deleted`=NULL 
						WHERE `employeeID`='$ID' ");
						
			$this->SQL->query("	UPDATE $this->BASE.employees_phases_bonuses
						SET `deleted`=NULL 
						WHERE `employeeID`='$ID' ");
						
			$this->SQL->query("	DELETE FROM $this->BASE.salarys_personal_data
						WHERE `employeeID`='$ID' LIMIT 1	");
						
			$this->SQL->commit();

			$this->unlock();

			return TRUE;
		}
	}
?>
