<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag create new inventory table or check for exists
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class INVENTORYTABLE	{

		# note: types are stocknames (feedstock, operating_suplies, stock);

		function __construct($type=FALSE)	{

			if (! $type) trigger_error('inventory table type is not defined !', E_USER_ERROR);

			global $__SQL, $__LANG;

			$this->SQL		=	&$__SQL;

			$this->STOCKBASE	=	'ebagstock';

			$this->TEMPBASE		=	'ebagtemp';

			if ($type == 'stock') {$this->type = 'finished_goods_stock';} else {$this->type = $type;}
		}

		public function gettable()	{

			# note: inventory tables are real tables (not temporary)
			#	connected with users personID to prevent errors
			#	they are deleted only when user submits or destroy
			#	the wholeinventory, thatway the inventory can be 
			#	continued between sessions

			$this->INV_TABLE = 'inventory_'.$this->type.'_'.$_SESSION['userID'];

			# check for table

			$this->SQL->query("	SHOW TABLES 
						FROM $this->TEMPBASE
						LIKE '$this->INV_TABLE'	");

			if (! $this->SQL->num_rows())	{

				# create new one

				$this->SQL->query("	CREATE TABLE 
							$this->TEMPBASE.$this->INV_TABLE 	(
												`stockID` int NOT NULL, 
												`new_quantity` decimal (14,2) NOT NULL
												) engine=innodb		");
			}

			return $this->INV_TABLE;
		}

		public function readtable()	{

			# read table data into

			$DATA	=	'';

			$this->SQL->query("	SELECT * 
						FROM $this->TEMPBASE.$this->INV_TABLE	");

			if (! $this->SQL->num_rows()) return $DATA;

			$NAME	=	array(	'feedstock'		=>	'feedstockname',
						'operating_suplies'	=>	'supliename',
						'finished_goods_stock'	=>	'articalname'	);

			$itemname = $NAME[$this->type];

			$this->SQL->IT1_RESULT = $this->SQL->RESULT;

			while ($IT1_RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

				$personID 	=	$IT1_RESULT['stockID'];

				$new_quantity	=	$IT1_RESULT['new_quantity'];

				$this->SQL->query("	SELECT `code`, `$itemname`, `unit`
							FROM $this->STOCKBASE.$this->type
							WHERE `personID`='$personID' LIMIT 1	");

				if ($this->SQL->num_rows())	{

					$RESULT	= $this->SQL->RESULT->fetch_assoc();

					$code	=	$RESULT['code'];
					$name	=	$RESULT[$itemname];
					$unit	=	$RESULT['unit'];

					$DATA	.=	<<<"EOT"
							<div class="columnames">
							<span class="spancolumns-code">$code</span>
							<span class="spancolumns-name-long">$name</span>
							<span class="spancolumns-quantity-long">$new_quantity</span>
							<span class="spancolumns-unit">$unit</span>
							</div>
EOT;
				}
			}			
			
			return $DATA;
		}
	}

?>
