<?php

	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.0
	 */

	/**
	 * eBag script to migrate version 2.0.2 to 3.0.0
	 */

	 set_time_limit(0);
	 
	 error_reporting(E_ALL);

	 if (isset($_POST['proceed']))	{
	 
		include('../helpers/basichelpers.php');
		include('../classes/INIload.class.php');
		include('../classes/SQL.class.php');
		
		$__CONF = new INI_load('../conf/eBag.ini');
			  
		$__SQL =  new SQL();
		
		class Migrate2to3	{
		
			function __construct()	{
			  
				global $__CONF, $__SQL;
			  
				$this->CONF = &$__CONF;
			  
				$this->SQL =  &$__SQL;
				  
				$this->yearsread();
			}
			  
			private function yearsread()	{

				$this->SQL->query("	SELECT `year`, `closed` 
							FROM ebag.years 
							ORDER BY `year`	");
							
				$this->YEARS = array();

				while ($RESULT = $this->SQL->RESULT->fetch_row()) $this->YEARS[$RESULT[0]] = $RESULT[1];

			}
			  
			private function column_exists($table, $column)	{
			  
				$exists = false;
				
				$this->SQL->query("SHOW COLUMNS FROM $table");
				
				while ($RESULT = $this->SQL->RESULT->fetch_assoc()) {
				
					if ($column == $RESULT['Field'])	{
					
						$exists = TRUE;
						
						break;
					}
				}
				
				return $exists;
			}       
			  
			function proceed()	{
			  
				# 1. create table in ebagtemp norestart
				
				$this->SQL->query("	CREATE TABLE IF NOT EXISTS ebagtemp.norestart 
										  (`true` int NOT NULL) engine=memory");
				
				# 2. reset passwords for users to root
				
				$rootpswd = $this->SQL->escape(md5('root'));
				
				$this->SQL->query("UPDATE ebag.users SET `password`='$rootpswd' ");
				
				# 3 add stocktype column to production order header
				
				$this->SQL->query("UPDATE ebag.users SET `password`='$rootpswd' ");
				
				foreach ($this->YEARS as $year=>$closed)	{
				
					$table = "ebagdata$year.production_orders_header";
				
					if (! $this->column_exists($table, 'stocktype'))	{
				
						$this->SQL->query("	ALTER TABLE $table 
									ADD `stocktype` INT NOT NULL AFTER `personID` ");
						
						$this->SQL->query("	UPDATE $table 
									SET `stocktype`='1' 
									WHERE `personID`!=0 ");
					}
				}
				
				# 4. add quantity_in_productin column to operating suplies
				
				foreach ($this->YEARS as $year=>$closed)	{
				
					if ($closed) {$table = "ebagdata$year.operating_suplies";} else {$table = "ebagstock.operating_suplies";}
				      
					if (! $this->column_exists($table, 'quantity_in_production'))	{
				
						$this->SQL->query("	ALTER TABLE $table
									ADD `quantity_in_production` decimal(10,2) AFTER `quantity` ");
						
						$this->SQL->query("	UPDATE $table
									SET `quantity_in_production`='0' 
									WHERE `personID`!=0 ");
					}
				}
				
				# add configuration directive for apc cache to eBag.ini
				
				$EOL = PHP_EOL;
				
				$handle = fopen('../conf/eBag.ini', 'a');
				
				if (! $handle) exit("Cannot open eBag.ini for write, please manually add lines :<br>\r\n[cache]<br>\r\nuse_apc_cache = 0");
				
				fwrite($handle, $EOL.'[cache]'.$EOL.'use_apc_cache	=	1'.$EOL); 
				
				fclose($handle);
			  }
		}
		
		$migrate = new Migrate2to3();
		$migrate -> proceed();
		
		$MESSAGE = 'Migration completed. All user password reset to root ! Please restart the server before you login !';
		
	}	else	{
	
		$MESSAGE = '<form action="'.$_SERVER['PHP_SELF'].'" name="migration" method="post" target="_self">eBag migration script from 2.0.2 to 3.0.0<br><br><input value="Proceed" type="submit" name="proceed"></form>';
	}
	 
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
	<head> 
		<meta HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8"/>
 		<meta name="robots" content="noindex,nofollow" />
		<title>eBag</title>
	</head>

	<body bgcolor="#FFFFFF">

			<table width=100% height="200" cellpadding="0" cellspacing="0">
				<tr><td align="center" valign="center">
					<font face="verdana, arial, helvetica" size="2"> <?php echo $MESSAGE; ?></font>
				</td></tr>
			</table>
	</body>
</html>