<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag mobile service, feedstock, stock search
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class MOBILEITEMREAD	{
	
		function __construct()	{

			global $__SQL, $__LANG, $__CONF;
			
			$this->contactID	=	FALSE;

			$this->SQL		=	&$__SQL;
			
			$this->BASE		=	'ebagstock';
			
			$this->LANG		=	&$__LANG;
			
		        $this->VALUTA		=	$__CONF->get('payments', 'valuta');
		        
		        $this->CURRENCY		=	$__CONF->get('payments', 'currency');
		        
		        $this->EXCHANGE_RATE	=	$__CONF->get('payments', 'exchange_rate');
			
			$this->ITEMNAME		=	FALSE;
			
			$this->ITEMCODE		=	FALSE;
			
			$this->itemID		=	FALSE;
		}
		
		function  set_type($type)	{
		
		
			$stocks		=	array(	'artical'	=>	'finished_goods_stock',
							'feedstock'	=>	'feedstock',
							'service'	=>	'services' );
							
			$this->STOCK	=	$stocks[$type];
			
			$this->NAME	=	$type.'name';
		}
		
		function setname($name=FALSE)	{
		
			if (! is_empty($name)) $this->ITEMNAME = $name;
		}
		
		function setcode($code=FALSE)	{
		
			if (! is_empty($code)) $this->ITEMCODE = $code;
		}

		public function readbyid($id='')	{

			$id	=	$this->SQL->escape($id);

			$this->SQL->query("	SELECT * 
						FROM $this->BASE.$this->STOCK
						WHERE `personID`='$id' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows()) return FALSE;

			return $this->fetch_data();
		}

		public function read()	{
		
			$where = array();
		
			if ($this->ITEMNAME) $where[] = "`$this->NAME`=".$this->SQL->n_escape($this->ITEMNAME);
			
			if ($this->ITEMCODE) $where[] = '`code`='.$this->SQL->n_escape($this->ITEMCODE);
			
			if (! ($count = count($where))) return FALSE;
			
			$WHERE = implode(' AND ', $where);
			
			$this->SQL->query("	SELECT * 
						FROM $this->BASE.$this->STOCK
						WHERE $WHERE AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows()) return FALSE;

			return $this->fetch_data();
		}
		
		public function fetch_data()	{
		
			$data 	= array();
		
			$RESULT = $this->SQL->RESULT->fetch_assoc();
			
			foreach ($RESULT as $column=>$value)	{
			
				if (is_empty($value)) continue;
			
				switch($column)	{
				
				
					case('deleted')					:
					case('quantity_on_opened_order_to_stock')	:	
					case('personID')				:	continue;
												break;

					case('origin')					:	$data[$this->LANG->get($column)] = $this->LANG->get("origin$value");
												break;
					
					case('supplier')				:
					case('unit')					:	${$column} = $value;
												break;
										
					case('supplierID')				:	$data[$this->LANG->get('supplier')] = $supplier;
					
												if ($value) $data[$this->LANG->get('supplier')] .= ' ('.$this->LANG->get('personID')." $value)";
												break;
												
					case('quantity')				:
					case('quantity_ordered')			:
					case('quantity_ordered_to_stock')		:
					case('quantity_in_production')			:
					case('quantity_as_part')			:	$data[$this->LANG->get($column)] = "$value $unit";
												break;
												
					case('tax')					:	$data[$this->LANG->get($column)] = "$value %";
												break;

					case('price')					:
					case('price_with_tax')				:
					case('purchase_price')				:
					case('calculation_price')			:	$data[$this->LANG->get($column)] = "$value $this->VALUTA <br> ".number_format(($value * $this->EXCHANGE_RATE), 2, '.', '')." $this->CURRENCY";
												break;
								
					default						:	$data[$this->LANG->get($column)] = $value;
												break;
				}
			}

			$this->itemID = $RESULT['personID'];
			
			return $data;
		}
		
		public function search()	{
		
			$where = array();
		
			if ($this->ITEMNAME) $where[] = "LOWER(`$this->NAME`) REGEXP '".$this->SQL->s_escape(mb_strtolower($this->ITEMNAME), 'REGEXP').'\'';
			
			if ($this->ITEMCODE) $where[] = 'LOWER(`code`) REGEXP \''.$this->SQL->s_escape(mb_strtolower($this->ITEMCODE), 'REGEXP').'\'';
			
			if (! ($count = count($where))) return FALSE;
			
			$WHERE = implode(' AND ', $where);
		
			# Case insensitive search 
			
			$this->SQL->query("	SELECT `personID`, `$this->NAME` 
						FROM $this->BASE.$this->STOCK
						WHERE $WHERE AND `deleted` IS NOT NULL");
			
			$data = FALSE;
			
			if ($this->SQL->num_rows())	{
			
				 $data = array();
				  
				 while ($RESULT = $this->SQL->RESULT->fetch_assoc()) $data[$RESULT['personID']]=$RESULT[$this->NAME];
			}
			
			return $data;
		}
	}

?>