<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag offer read to details
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class OFFERDETAILS	{

		function __construct()	{

			global $__SQL, $__CONF, $__LANG;

			$this->SQL	=	&$__SQL;
			
			$this->LANG	=	&$__LANG;
			
			$this->FORMAT	=	$__CONF->get('date', 'sql_format');
			
			$this->APC	=	$__CONF->get('cache', 'use_apc_cache');
			
			$this->BASE	=	$_SESSION['BASE'];
		}

		public function base($BASE)	{

			$this->BASE	=	$BASE;
		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES	$this->BASE.offers_header WRITE, 
							$this->BASE.offers_data WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function read($ID)	{

			# first check te gived base exists or not

			$this->SQL->query("SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = '$this->BASE'");

			if (! $this->SQL->num_rows()) return FALSE;
			
			# read payments and deliverys
			
			$__PAYMENTS	= new PAYMENTloader($this->APC);

			$PAYMENT_FORMS	= $__PAYMENTS->getnames();
			
			unset($__PAYMENTS);
			
			$__DELIVERYS	= new DELIVERYloader($this->APC);

			$DELIVERY_TYPES	= $__DELIVERYS->gettypes();
			
			unset($__DELIVERYS);

			# read

			$DATA	=	FALSE;

			$ID	=	$this->SQL->escape($ID);

			$this->lock();
		
			$this->SQL->query("	SELECT	`contactname`, `country`, `city`, `zip`, `street`, `service_discount`, `article_discount`, `deadline_days`, 
							`comment`, `currency`, `exchange_rate`, `session_discount`, `use_session_discount`, 
							`use_service_discount`, `use_article_discount`, `annotation`, `offer_in_valuta`, 
							DATE_FORMAT(`date_of_creation`, '$this->FORMAT') AS `date_of_creation`, 
							`delivery_form`, `payment_form`, `ordered`, `orderID` 
						FROM $this->BASE.offers_header
						WHERE personID='$ID' AND `deleted` IS NOT NULL LIMIT 1"		);

			if ($this->SQL->num_rows())	{

				$DATA	=	$this->SQL->RESULT->fetch_assoc();

				$DATA['offer_year']	=	str_replace('ebagdata', '' , $this->BASE);

				if ($DATA['ordered'])	{

					$DATA['order_state'] = $DATA['orderID'].'/'.$DATA['offer_year'];

				}	else	  {

					$DATA['order_state'] = $this->LANG->get('no');
				}

				if ($DATA['offer_in_valuta']) {$EXCHANGE = 1;} else {$EXCHANGE = $DATA['exchange_rate'];}

				$DATA['deadline_days']	.=	' '.$this->LANG->get('daysword');

				if (isset($PAYMENT_FORMS[$DATA['payment_form']])) $DATA['payment_form']	= $PAYMENT_FORMS[$DATA['payment_form']];

				unset($PAYMENT_FORMS);

				if (isset($DELIVERY_TYPES[$DATA['delivery_form']])) $DATA['delivery_form'] = $DELIVERY_TYPES[$DATA['delivery_form']];

				unset($DELIVERY_TYPES);

				# read data
		
				$this->SQL->query("	SELECT `code`, `name`, `quantity`, `unit`, `price`, `tax`, `type` 
							FROM $this->BASE.offers_data 
							WHERE `offerID`='$ID' AND `deleted` IS NOT NULL	ORDER BY `personID` ");

				# note: price is calculated with defined discounts

				$SESSION_COEF = $SERVICE_COEF = $ARTICLE_COEF = 1;

				if (($DATA['use_session_discount']) && ($DATA['session_discount']>0))	$SESSION_COEF = (100-$DATA['session_discount']) / 100;

				if (($DATA['use_service_discount']) && ($DATA['service_discount']>0))	$SERVICE_COEF = (100-$DATA['service_discount']) / 100;

				if (($DATA['use_article_discount']) && ($DATA['article_discount']>0))	$ARTICLE_COEF = (100-$DATA['article_discount']) / 100;

				if ($this->SQL->num_rows())	{
				
					# Initialize vars
					
					$DATA['price_sum'] = $DATA['price_tax'] = $DATA['price_sum_tax'] = 0;
					
					$DATA['code'] = $DATA['name'] = $DATA['quantity'] = $DATA['unit'] = $DATA['price'] = $DATA['tax'] = $DATA['sum'] = $DATA['sum_tax'] = array();

					while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

						$DATA['code'][]		=	$RESULT['code'];
						$DATA['name'][]		=	$RESULT['name'];
						$DATA['quantity'][]	=	$RESULT['quantity'];
						$DATA['unit'][]		=	$RESULT['unit'];

						# note: which discount to use

						if ($RESULT['type']=='a')	{

							$DISCOUNT_COEF	=	$ARTICLE_COEF;

						}	else	{

							$DISCOUNT_COEF	=	$SERVICE_COEF;
						}

						$PRICE			=	$RESULT['price']*$EXCHANGE*$SESSION_COEF*$DISCOUNT_COEF;

						$DATA['price'][]	=	number_format($PRICE, 2, '.', '');
						
						$DATA['tax'][]		=	$RESULT['tax'];

						$SUM			=	$PRICE*$RESULT['quantity'];
						
						$TAX			=	$SUM * $RESULT['tax']/100;
						
						$SUM_TAX		=	$SUM + $TAX;						

						$DATA['sum'][]		=	number_format($SUM, 2, '.', '');
						
						$DATA['sum_tax'][]	=	number_format($SUM_TAX, 2, '.', '');						

						$DATA['price_sum']	+=	$SUM;

						$DATA['price_tax']	+=	$TAX;
						
						$DATA['price_sum_tax']	+=	$SUM_TAX;
					}
					
					$DATA['price_sum']	=	number_format($DATA['price_sum'], 2, '.', '');
					$DATA['price_tax']	=	number_format($DATA['price_tax'], 2, '.', '');
					$DATA['price_sum_tax']	=	number_format($DATA['price_sum_tax'], 2, '.', '');

				}	else	  {

					$DATA	=	FALSE;
				}
			}

			$this->unlock();

			return $DATA;
		}
	}

?>
