<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 5.0.0
	 */

	/**
	 * eBag offer read
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class OFFERREAD	{

		function __construct()	{

			global $__SQL, $__CONF, $__LANG;

			$this->SQL	=	&$__SQL;

			$this->LANG	=	&$__LANG;

			$this->BASE	=	$_SESSION['BASE'];
		}

		public function base($BASE)	{

			$this->BASE	=	$BASE;
		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES	$this->BASE.offers_header WRITE, 
							$this->BASE.offers_data WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function state($ID)	{

			$STATE	=	FALSE;

			$this->SQL->query("	SELECT `ordered` 
						FROM $this->BASE.offers_header 
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$RESULT	=	$this->SQL->RESULT->fetch_row();

				if ($RESULT[0]) $STATE = 'orderedoffer';

			}	else	  {

				$STATE = 'unexistentoffer';
			}

			return $STATE;
		}

		public function read($ID)	{

			# first check te gived base exists or not

			$this->SQL->query("SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = '$this->BASE'");

			if (! $this->SQL->num_rows()) return 'unexistentoffer';

			# read

			$ID	=	$this->SQL->escape($ID);

			$DATA	=	FALSE;

			$this->lock();

			$STATE = $this->state($ID);

			if ($STATE)	{

				$this->unlock();

				return $STATE;
			}

			$this->SQL->query("	SELECT	`contactID`, `contactname`, `deadline_days`, `service_discount`, `article_discount`, `use_session_discount`,
							`use_service_discount`, `use_article_discount`, `exchange_rate`, `currency`, `valuta`, `session_discount`, `comment`,
							`annotation`, `offer_in_valuta`, `delivery_form`, `payment_form`
						FROM $this->BASE.offers_header
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1");

			if ($this->SQL->num_rows())	{
			
				$DATA	=	$this->SQL->RESULT->fetch_assoc();
				
				$DATA['offer_year'] = str_replace('ebagdata', '' , $this->BASE);

				# read data
		
				$this->SQL->query("	SELECT `code`, `name`, `quantity`, `unit`, `price`, `tax`, `type` 
							FROM $this->BASE.offers_data 
							WHERE `offerID`='$ID' AND `deleted` IS NOT NULL	ORDER BY `personID` ");

				if ($this->SQL->num_rows())	{

					# Initialize vars
				
					$DATA['code'] = $DATA['name'] = $DATA['quantity'] = $DATA['unit'] = $DATA['price'] = $DATA['tax'] = $DATA['type'] = array();
				
					while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

						$DATA['code'][]		=	$RESULT['code'];
						$DATA['name'][]		=	$RESULT['name'];
						$DATA['quantity'][]	=	$RESULT['quantity'];
						$DATA['unit'][]		=	$RESULT['unit'];
						$DATA['price'][]	=	$RESULT['price'];
						$DATA['tax'][]		=	$RESULT['tax'];
						$DATA['type'][]		=	$RESULT['type'];
					}

				}	else	  {

					$DATA	=	FALSE;
				}
			}

			$this->unlock();

			if (! $DATA) {return 'unexistentoffer';} else {return $DATA;}
		}
	}

?>
