<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag partially delivery
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class PARTIALLYDELIVERY	{

		function __construct()	{

			global $__SQL, $__CONF;	

			$this->SQL		=	&$__SQL;

			$this->CONF		=	&$__CONF;

			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';
		}

		public function getid()		{

			if (isset($this->deliveryID)) {return $this->deliveryID;} else {return FALSE;}
		}

		private function lock()	{

			$this->SQL->query("	LOCK TABLES 	$this->BASE.orders_header WRITE, 
								$this->BASE.orders_data WRITE, 
								$this->BASE.deliverys_header WRITE, 
								$this->BASE.deliverys_data WRITE, 
								$this->BASE.production_orders_header WRITE,
								$this->STOCKBASE.finished_goods_stock WRITE, 
								ebag.companydata WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function readpersonIDs($personIDs)	{

			$this->personID_s	=	array();
			$this->orderID_s	=	array();
			$this->personID_str	=	'';
			$this->orderID_str	=	'';

			foreach ($personIDs as $item)		{

				$personID	=	(integer)($item);

				if (! $personID) continue;

				$this->SQL->query("	SELECT `orderID` 
							FROM $this->BASE.orders_data
							WHERE `personID`='$personID' AND `date_of_delivery` IS NULL AND `deleted` IS NOT NULL
							AND ((orders_data.productionorderID IS NULL) OR (orders_data.productionorderID NOT IN (	SELECT `personID` 
																		FROM $this->BASE.production_orders_header 
																		WHERE `date_of_finishing` IS NULL AND `deleted` IS NOT NULL)))"	);

				if ($this->SQL->num_rows()) {

					$this->personID_s[]	=	$personID;

					$RESULT			=	$this->SQL->RESULT->fetch_row();

					$this->orderID_s[]	=	$RESULT[0];
				}
			}

			if ((! count($this->personID_s)) or (! count($this->orderID_s))) return FALSE;
			
			# Sort the personID_s as they are ordered by personID
			
			sort($this->personID_s, SORT_NUMERIC);

			$this->personID_str	=	implode(',', $this->personID_s);

			# remove duplicates

			$this->orderID_s	=	array_unique($this->orderID_s);

			$this->orderID_str	=	implode(',', $this->orderID_s);

			return TRUE;
		}

		public function delivery($DATA)	{

			if ((! isset($DATA['personID'])) or (! count($DATA['personID']))) return 'nothingisselected';

			$personIDs	=	$DATA['personID'];

			$comment	=	$DATA['comment'];

			$annotation	=	$DATA['annotation'];

			if ((isset($DATA['add2deliveryID'])) && ($DATA['add2deliveryID']))	{

				$this->deliveryID = $this->SQL->escape($DATA['add2deliveryID']);

				$ACTION	=	'updated';

			}	else	  {

				$ACTION	=	'writed';
			}

			unset($DATA);

			# start transaction

			$this->SQL->transaction();
		
			$this->lock();

			# make list
		
			if (! $this->readpersonIDs($personIDs))	{

				$errtxt = 'unexistoredeliveredentorder';

			}	else	{

				if (count($personIDs) != count($this->personID_s)) $errtxt = 'orderschangedinmeantime';
			}
		
			if (isset($errtxt))	{

				$this->SQL->rollback();

				$this->unlock();

				return ;
			}

			unset($personIDs);

			# check the orders is for one customer

			$this->SQL->query("	SELECT	`contactID` 
						FROM $this->BASE.orders_header 
						WHERE `personID` IN ($this->orderID_str) AND `deleted` IS NOT NULL GROUP BY `contactID`	");

			if ($this->SQL->num_rows() != 1)	{

				$this->SQL->rollback();

				$this->unlock();

				return 'differentcustomerids';
			}

			$RESULT		=	$this->SQL->RESULT->fetch_row();

			$contactID	=	$RESULT[0];

			# if is defined exist delivery ID check existens & customer

			if (isset($this->deliveryID))	{

				$this->SQL->query("	SELECT `contactID`, `billed`, `payment_form`, `delivery_form`
							FROM $this->BASE.deliverys_header 
							WHERE `personID`='$this->deliveryID' AND `deleted` IS NOT NULL	");

				if (! $this->SQL->num_rows())	{

					$this->SQL->rollback();

					$this->unlock();

					return 'unexistentdelivery';
				}

				$RESULT	=	$this->SQL->RESULT->fetch_assoc();
			
				if ($RESULT['contactID'] != $contactID) $errtxt = 'delivery2wrongcontact';

				if ($RESULT['billed'])	$errtxt	= 'delivery2billed';

				$payment_form	=	$RESULT['payment_form'];

				$delivery_form	=	$RESULT['delivery_form'];

				if (isset($errtxt))	{

					$this->SQL->rollback();

					$this->unlock();

					return $errtxt;
				}
			}

			# check the payment form and delivery form is the same for orders

			$this->SQL->query("	SELECT `payment_form` 
						FROM $this->BASE.orders_header 
						WHERE `personID` IN ($this->orderID_str) AND `deleted` IS NOT NULL GROUP BY `payment_form`	");

			if ($this->SQL->num_rows() != 1)	$errtxt	= 'differentpaymentorders';

			$RESULT = $this->SQL->RESULT->fetch_row();

			if ((isset($payment_form)) && ($payment_form != $RESULT[0])) $errtxt = 'differentpaymentfromdefined';

			$this->SQL->query("	SELECT `delivery_form` 
						FROM $this->BASE.orders_header 
						WHERE `personID` IN ($this->orderID_str) AND `deleted` IS NOT NULL GROUP BY `delivery_form`	");

			if ($this->SQL->num_rows() != 1)	$errtxt	= 'differentdeliveryorders';

			$RESULT = $this->SQL->RESULT->fetch_row();

			if ((isset($delivery_form)) && ($delivery_form != $RESULT[0])) $errtxt = 'differentdeliveryformdefined';

			if (isset($errtxt))	{

				$this->SQL->rollback();

				$this->unlock();

				return $errtxt;
			}

			# use first ID to read data for delivery header

			$orderID	=	$this->orderID_s[0];

			$currency	=	$this->SQL->n_escape($this->CONF->get('payments', 'currency'));

			$companyID	=	FALSE;

			$this->SQL->query("	SELECT MAX(`personID`) AS `personID` 
						FROM ebag.companydata	");

			if ($this->SQL->num_rows())	{

				$RESULT		=	$this->SQL->RESULT->fetch_row();
				$companyID	=	"'".$RESULT[0]."'";
			}

			if (($currency == 'NULL') or (! $companyID))	{

				$this->SQL->rollback();

				$this->unlock();

				if (! $companyID) {return 'nocompanyID';} else {return 'fatalerror';}
			}

			$now	=	date("Y-m-d");

			if (! isset($this->deliveryID))		{

				# read header data from order and write it to delivery

				# note: if delivery address is defined delivery there

				$this->SQL->query("	SELECT `delivery_country` 
							FROM $this->BASE.orders_header
							WHERE `personID`='$orderID' LIMIT 1	");

				# note: must to be row, checked before after lock

				$RESULT	=	$this->SQL->RESULT->fetch_row();

				if ($RESULT[0])		{

					# read second delivery

					$this->SQL->query("	SELECT 	`contactID`, `contactname`, `delivery_country` AS `country`, `delivery_city` AS `city`,
									`delivery_street` AS `street`, `delivery_zip` AS `zip`, `account1`, `bank1`,
									`account2`, `bank2`, `delivery_day_of_week`, `contacttype`, `seller`, `delivery_form`, `payment_form`
								FROM $this->BASE.orders_header WHERE `personID`='$orderID' LIMIT 1	");

				}	else	  {

					$this->SQL->query("	SELECT	`contactID`, `contactname`, `country`, `city`, `zip`, `street`, `account1`, `bank1`, 
									`account2`, `bank2`, `delivery_day_of_week`, `contacttype`, `seller`, `delivery_form`, 
									`payment_form` 
								FROM $this->BASE.orders_header WHERE `personID`='$orderID' LIMIT 1	");
				}

				$RESULT	=	$this->SQL->RESULT->fetch_assoc();

				foreach ($RESULT as $key=>$val)	$RESULT[$key] = $this->SQL->nr_escape($val);

				extract($RESULT);

				$comment	=	$this->SQL->n_escape($comment);

				$annotation	=	$this->SQL->n_escape($annotation);

				$this->SQL->query("	INSERT INTO $this->BASE.deliverys_header 
							VALUES 
							( 	NULL, $companyID, $contactID, $contactname, $country, $city, $zip, $street,
								$account1, $bank1, $account2, $bank2, $delivery_day_of_week, $contacttype, $seller, 
								$comment, $annotation, $currency, $delivery_form, $payment_form,
								NULL, '0', NULL, '$now', NULL, '0' )	");

				$this->deliveryID	=	$this->SQL->lastid();

			}	else	  {

				# update exist delivery header

				if ((! is_empty($comment)) or (! is_empty($annotation)))	{

					$this->SQL->query("	SELECT `comment`, `annotation`, `payment_form`, `delivery_form` 
								FROM $this->BASE.deliverys_header
								WHERE `personID`='$this->deliveryID' AND `deleted` IS NOT NULL LIMIT 1	");

					$RESULT		=	$this->SQL->RESULT->fetch_assoc();

					if (! is_empty($comment))	$comment = $this->SQL->r_escape($RESULT['comment']).$this->SQL->escape($comment);

					if (! is_empty($annotation))	$annotation = $this->SQL->r_escape($RESULT['annotation']).$this->SQL->escape($annotation);

					$this->SQL->query("	UPDATE $this->BASE.deliverys_header
								SET `comment`='$comment', `annotation`='$annotation'
								WHERE `personID`='$this->deliveryID' AND `deleted` IS NOT NULL LIMIT 1	");
				}
			}

			# check the stock

			foreach ($this->personID_s as $datapersonID)	{

				$this->SQL->query("	SELECT `code`, `quantity`
							FROM $this->BASE.orders_data 
							WHERE `personID`='$datapersonID' AND `deleted` IS NOT NULL LIMIT 1	");

				$RESULT = $this->SQL->RESULT->fetch_assoc();

				$code		=	$this->SQL->nr_escape($RESULT['code']);
				$quantity	=	$RESULT['quantity'];

				$this->SQL->query("	SELECT `personID` 
							FROM $this->STOCKBASE.finished_goods_stock
							WHERE `code`=$code AND `quantity`>=$quantity AND `deleted` IS NOT NULL LIMIT 1	");

				if (! $this->SQL->num_rows()) 		{

					$errtxt = 'undeliverableitemsfound';

					break;
				}
			}

			if (isset($errtxt)) {

				$this->SQL->rollback();

				$this->unlock();

				return $errtxt;
			}

			foreach ($this->personID_s as $datapersonID)	{

				$this->SQL->query("	SELECT `orderID`, `code`, `articalname`, `quantity`, `unit`, `price`, `tax`
							FROM $this->BASE.orders_data
			  				WHERE `personID`='$datapersonID' AND `deleted` IS NOT NULL LIMIT 1	");

				$RESULT	=	$this->SQL->RESULT->fetch_assoc();

				$orderID	=	$RESULT['orderID'];
				$code		=	$this->SQL->nr_escape($RESULT['code']);
				$articalname	=	$this->SQL->nr_escape($RESULT['articalname']);
				$quantity	=	$RESULT['quantity'];
				$unit		=	$this->SQL->nr_escape($RESULT['unit']);
				$price		=	$RESULT['price'];
				$tax		=	$this->SQL->nr_escape($RESULT['tax']);

				# read & calculate coef's to every order because they not must to be the same

				$this->SQL->query("	SELECT	`article_discount`, `exchange_rate`, `session_discount`, `use_session_discount`, `use_article_discount` 
							FROM $this->BASE.orders_header 
							WHERE `personID`='$orderID' AND `deleted` IS NOT NULL LIMIT 1	");

				$RESULT	=	$this->SQL->RESULT->fetch_assoc();

				extract($RESULT);

				$SESSION_COEF = $ARTICLE_COEF = 1;

				if (($use_session_discount) && ($session_discount>0))	$SESSION_COEF = (100-$session_discount) / 100;

				if (($use_article_discount) && ($article_discount>0))	$ARTICLE_COEF = (100-$article_discount) / 100;

				$GLOBAL_COEF	=	$SESSION_COEF * $ARTICLE_COEF * $exchange_rate;

				$price		=	$price * $GLOBAL_COEF;

				# write item into delivery data

				$this->SQL->query("	INSERT INTO $this->BASE.deliverys_data 
							VALUES 	
							(NULL, '$this->deliveryID', $code, $articalname, '$quantity', $unit, '$price', $tax, '$datapersonID', '0')	");

				# update order data

				$this->SQL->query("	UPDATE $this->BASE.orders_data
							SET `deliverylistID`='$this->deliveryID', `date_of_delivery`='$now'
							WHERE `personID`='$datapersonID' AND `deleted` IS NOT NULL LIMIT 1	");

				# update delivery header connected_with_order

				$this->SQL->query("	SELECT `connected_with_orders` 
							FROM $this->BASE.deliverys_header
				  			WHERE 	(`connected_with_orders` NOT REGEXP '-$orderID-' OR `connected_with_orders` IS NULL) 
								AND `personID`='$this->deliveryID' AND `deleted` IS NOT NULL LIMIT 1	");

				if ($this->SQL->num_rows())	{

					$RESULT	=	$this->SQL->RESULT->fetch_row();

					if ($connected_with_orders = $RESULT[0])	{

						$connected_with_orders	.=	"$orderID-";

					}	else	  {

						$connected_with_orders	=	"-$orderID-";
					}

					$this->SQL->query("	UPDATE $this->BASE.deliverys_header
								SET `connected_with_orders`='$connected_with_orders' 
								WHERE `personID`='$this->deliveryID' AND `deleted` IS NOT NULL LIMIT 1	");
				}

				# check there is more not delivered item on this order

				$this->SQL->query("	SELECT COUNT(*) 
							FROM $this->BASE.orders_data
							WHERE `date_of_delivery` IS NULL AND `orderID`='$orderID' AND `deleted` IS NOT NULL	");

				$RESULT	=	$this->SQL->RESULT->fetch_row();

				# note: delivery states 2=>part, 1=>yes

				if ($RESULT[0])	{$DELIVERED = 2;} else {$DELIVERED = 1;}


				$this->SQL->query("	UPDATE $this->BASE.orders_header
							SET `delivered`='$DELIVERED' 
							WHERE `personID`='$orderID' AND `deleted` IS NOT NULL LIMIT 1	");

				# update the stock

				$this->SQL->query("	UPDATE $this->STOCKBASE.finished_goods_stock
							SET 	quantity=quantity-$quantity, 
								quantity_ordered=quantity_ordered-$quantity 
							WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");
			}

			$this->SQL->commit();

			$this->unlock();

			return $ACTION;	
		}
	}

?>
