<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag change production order phase 
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}
	
	load_f('is_int_positive');

	class PRODUCTIONPHASECHANGE	{

		function __construct()	{

			global $__SQL, $__CONF;

			$this->SQL		=	&$__SQL;

			$this->BASE		=	$_SESSION['BASE'];
			
			$__PHASES		= 	new PHASEloader($__CONF->get('cache', 'use_apc_cache'));

			$this->DEFAULT_PHASE	=	$__PHASES->getdefault();

			unset($__PHASES);
			
		}

		private function lock()		{

			$this->SQL->query("	LOCK TABLES	$this->BASE.production_orders_header WRITE, 
								$this->BASE.production_orders_phases WRITE,
								$this->BASE.addressbook WRITE, 
								$this->BASE.employees WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function finisherexist($FINISHER)	{

			list($TYPE, $FINISHERID)	=	explode('_', $FINISHER);

			if ($TYPE == 'employee')	{

				$COMMAND = "SELECT `employeename` FROM $this->BASE.employees WHERE `personID`='$FINISHERID' AND `deleted` IS NOT NULL LIMIT 1";

			}	else	   {

				$COMMAND = "SELECT `contactname` FROM $this->BASE.addressbook WHERE `personID`='$FINISHERID' AND `deleted` IS NOT NULL LIMIT 1";
			}

			$this->SQL->query($COMMAND);

			if (! $this->SQL->num_rows()) return FALSE;

			return TRUE;
		}

		public function change($DATA)	{

			extract($DATA);

			$this->SQL->transaction();
		
			$this->lock();

			# check existens and that is not finished

			$productionorderID	=	$this->SQL->escape($productionorderID);

			$this->SQL->query("	SELECT `production_phase`, `date_of_finishing`
						FROM $this->BASE.production_orders_header 
						WHERE `personID`='$productionorderID' AND `deleted` IS NOT NULL LIMIT 1	  ");

			if ($this->SQL->num_rows())	{
			
				$RESULT = $this->SQL->RESULT->fetch_assoc();
			
				if ($RESULT['date_of_finishing']) $errtxt = 'finishedproductionorder';

			}	else	  {
			
				$errtxt = 'unexistentproductionorder';			
			}
			
			if (isset($errtxt))	{
			
				$this->SQL->rollback();

				$this->unlock();

				return $errtxt;
			}

			# check the phasepersonID exist yet

			$personID	=	$this->SQL->escape($personID);

			$this->SQL->query("	SELECT `productionorderID` 
						FROM $this->BASE.production_orders_phases
						WHERE `personID`='$personID' LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'unexistentphase';
			}

			#
			# delete current phase
			#

			if ((isset($delete_current)) && ($delete_current))	{
			
				if ($production_phase != $this->DEFAULT_PHASE)		{
				
					# security check read number of rows
					
					$this->SQL->query("	SELECT `personID`
								FROM $this->BASE.production_orders_phases 
								WHERE `productionorderID`='$productionorderID'	");
								
					if ($this->SQL->num_rows() <= 1) $errtxt = 'deletingfirstphase';

				}	else	 {
				
					$errtxt = 'deletingfirstphase';
				}
				
				if (isset($errtxt))	{
				
					$this->SQL->rollback();

					$this->unlock();

					return $errtxt;
				}
				
				# delete current phase

				$this->SQL->query("	DELETE 
							FROM $this->BASE.production_orders_phases 
							WHERE `personID`='$personID' LIMIT 1	");

				# read the last phase

				$this->SQL->query("	SELECT MAX(`personID`) AS `personID` 
							FROM $this->BASE.production_orders_phases 
							WHERE `productionorderID`='$productionorderID'	");

				$RESULT	=	$this->SQL->RESULT->fetch_row();

				if ($LASTID = $RESULT[0])	{

					$this->SQL->query("	UPDATE $this->BASE.production_orders_header 
								SET `production_phase`=(	SELECT `production_phase` 
												FROM $this->BASE.production_orders_phases
												WHERE `personID`='$LASTID' LIMIT 1	)
								WHERE `personID`='$productionorderID' LIMIT 1	");
				}

				$this->SQL->commit();

				$this->unlock();

				return TRUE;	
			}

			#
			# change the current phase (but the other data leave untoucht)
			#

			if 	(((isset($next_phase)) && ($next_phase)) &&
				((! isset($newfinisher)) or (! $newfinisher)) &&
				((! isset($process_time)) or (is_empty($process_time))))	{
				
				# From version 6.0.0 one phase can be present more time, only default (feedstock) once

				if ($next_phase == $this->DEFAULT_PHASE)	{
				
					$errtxt = 'defaultphaseononce';
					
				}	else	  {
					
					# The first phase cannot be changed
					
					# Because the default phase can not be recorded more time
					# and cannot be changed, if one row found, that is 

					$this->SQL->query("	SELECT `personID`
								FROM $this->BASE.production_orders_phases 
								WHERE `personID`='$personID' AND `production_phase`='{$this->DEFAULT_PHASE}' LIMIT 1");
								
					if ($this->SQL->num_rows()) $errtxt = 'deletingfirstphase';
				}

				if (isset($errtxt))	{

					$this->SQL->rollback();

					$this->unlock();

					return $errtxt;
				}
				
				$next_phase	=	$this->SQL->escape($next_phase);

				$this->SQL->query("	UPDATE $this->BASE.production_orders_header  
							SET `production_phase`='$next_phase' 
							WHERE `personID`='$productionorderID' LIMIT 1	");

				$this->SQL->query("	UPDATE $this->BASE.production_orders_phases 
							SET `production_phase`='$next_phase' 
							WHERE `personID`='$personID' LIMIT 1	");

				$this->SQL->commit();

				$this->unlock();

				return TRUE;	
			}

			#
			# open accidentaly closed (finished) phase
			#

			if 	(((! isset($next_phase)) or (! $next_phase)) &&
				((! isset($newfinisher)) or (! $newfinisher)) &&
				((! isset($process_time)) or (is_empty($process_time))))	{

				$this->SQL->query("	UPDATE $this->BASE.production_orders_phases 
							SET `finisher`=NULL, `date`=NULL, `process_time`=NULL
							WHERE `personID`='$personID' LIMIT 1	");

				$this->SQL->commit();

				$this->unlock();

				return TRUE;	
			}

			#
			# update last phase finisher & process time 
			#

			if 	(((! isset($next_phase)) or (! $next_phase)) &&
					(	(! is_empty($process_time)) or 
						((isset($newfinisher)) && ($newfinisher))
					)
				)		{

					
				if ((is_empty($process_time)) or (! is_int_positive($process_time)))	$errtxt = 'invalidprocesstime';

				if (! isset($errtxt))	{

					if ((isset($newfinisher)) && ($newfinisher))	{

						if (! $this->finisherexist($newfinisher)) {$errtxt = 'finisherdeleted';} else {$ADDFINISHER = TRUE;}

					}	else	  {

						$ADDFINISHER = FALSE;
					}
				}

				if (! isset($errtxt))	{

					$finisher	=	$this->SQL->n_escape($newfinisher);

					if ($ADDFINISHER) {$ADD_ = "`finisher`=$finisher,";} else {$ADD_ = '';}

					$now		=	date("Y-m-d");

					$this->SQL->query("	UPDATE $this->BASE.production_orders_phases
								SET $ADD_ `process_time`='$process_time', `date`='$now'
								WHERE `personID`='$personID' LIMIT 1	");

					$this->SQL->commit();

					$this->unlock();

					return TRUE;	


				}	else	  {

					$this->SQL->rollback();

					$this->unlock();

					return $errtxt;
				}
			}

			#
			# step to the next phase
			#

			if 	(((isset($next_phase)) && ($next_phase)) &&
					(	(! is_empty($process_time)) or 
						((isset($newfinisher)) && ($newfinisher))
					)
				)	{

						# check process time

						if ((is_empty($process_time)) or (! is_int_positive($process_time)))	$errtxt = 'invalidprocesstime';

						# check finisher

						if (! isset($errtxt))	{

							if ((isset($newfinisher)) && ($newfinisher))	{

								if (! $this->finisherexist($newfinisher)) $errtxt = 'finisherdeleted';

							}	else	  {
							
								# check maybe last phase is already finished but no next phase defined

								$this->SQL->query("	SELECT MAX(`personID`) AS `personID` 
											FROM $this->BASE.production_orders_phases 
											WHERE `productionorderID`='$productionorderID'	");

								$RESULT	=	$this->SQL->RESULT->fetch_row();
								
								$newfinisher = '';

								if ($LASTID = $RESULT[0])	{
								
									$this->SQL->query(" SELECT `finisher`
											    FROM $this->BASE.production_orders_phases
											    WHERE `productionorderID`='$productionorderID' AND `personID`='$LASTID' LIMIT 1	");
											    
									$RESULT	= $this->SQL->RESULT->fetch_row();
									
									$newfinisher = $RESULT[0];
								}

								if (! $newfinisher) $errtxt = 'invalidfinisher';
							}
						}

						# From version 6.0.0 one phase can be present more time, only default (feedstock) once
						
						if ($next_phase == $this->DEFAULT_PHASE) $errtxt = 'defaultphaseononce';

						$next_phase	=	$this->SQL->n_escape($next_phase);
						$finisher	=	$this->SQL->n_escape($newfinisher);
						$now		=	date("Y-m-d");

						if (! isset($errtxt))	{

							# update current

							$this->SQL->query("	UPDATE $this->BASE.production_orders_phases
										SET `finisher`=$finisher, `date`='$now', `process_time`='$process_time'
										WHERE `personID`='$personID' LIMIT 1	");

							# insert next phase

							$this->SQL->query("	INSERT INTO $this->BASE.production_orders_phases 
										VALUES 
										(NULL, '$productionorderID', $next_phase, NULL, NULL, NULL)	");

							# update production order header

							$this->SQL->query("	UPDATE $this->BASE.production_orders_header 
										SET `production_phase`=$next_phase 
										WHERE `personID`='$productionorderID' AND `deleted` IS NOT NULL LIMIT 1	");

							$this->SQL->commit();

							$this->unlock();

							return TRUE;	

						}	else	 {

							$this->SQL->rollback();

							$this->unlock();

							return $errtxt;
						}
			}

		# note: for safety only

		$this->SQL->rollback();

		$this->unlock();

		return 'usererror';

		}

	}
?>
