<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag salary details
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class SALARYDETAILS	{

		function __construct()	{

			global $__SQL, $__LANG, $__CONF;

			$this->SQL	=	&$__SQL;

			$this->LANG	=	&$__LANG;

			$this->FORMAT	=	$__CONF->get('date', 'sql_format');

			$this->BASE	=	$_SESSION['BASE'];
		}

		public function read($ID)	{

			$ID	=	$this->SQL->escape($ID);

			$DATA	=	FALSE;

			$this->SQL->query("	SELECT 	`companyID`, `employeeID`, `employeename`, `currency`, `salary_globals`, `fix_payment`, 
							`working_hour_value`, `bonus_config`, `additionals`, `credits`, `month`, `month_part`,
							DATE_FORMAT(`date_of_creation`, '$this->FORMAT') AS `date_of_creation`, 
							`E_work`, `E_overtime_work`, `E_night_work`, `E_night_overtime_work`, `E_night_holiday_work`,
							`E_night_overtime_holiday_work`, `E_sick_leave`, `E_sick_leave_100`, `E_holiday_work`, `E_holiday_overtime_work`,
							`E_holiday`, `E_annual_leave`, `E_bonus_production`, `E_bonus_services`, `E_bonus_product_sell`,
							`E_bonus_service_sell`, `Salary_BASE`, `E_payment`,
							`comment`, `annotation`
						FROM $this->BASE.salarys
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$DATA = $this->SQL->RESULT->fetch_assoc();
				
				foreach (array('salary_globals', 'additionals', 'credits', 'bonus_config') as $type) $DATA[$type] = unserialize($DATA[$type]);

				$coefs = array();

				foreach (array('overtime_work', 'night_work', 'holiday_work', 'sick_leave', 'annual_leave', 'holiday') as $COEF) 	{

					array_push($coefs, $this->LANG->get($COEF).' '.$DATA['salary_globals'][$COEF].' %');

					unset($DATA['salary_globals'][$COEF]);
				}

				$DATA['salary_globals']['coefs'] = $coefs; unset($coefs);

				$DATA['month'] = $this->LANG->get('monthname'.$DATA['month']);
				
				if ($DATA['month_part'])	{
				      
				      if ($DATA['month_part'] == 1) {$DATA['month'] .= ' I';} else {$DATA['month'] .= ' II';}
				}
				
				$units = array(	'bonus_percent_' => '%',
						'bonus_fix_'	 => $DATA['currency'],
						'bonus_to_'	 => ''	);
				
				$bonus_list = array();
				
				foreach(array('production', 'services', 'product_sell', 'service_sell') as $type)	{
				
					foreach(array('bonus_fix_', 'bonus_percent_', 'bonus_to_') as $sub)	{
					
						if ($sub == 'bonus_to_') {
						  
							 if ($DATA['bonus_config'][$sub.$type] != 3 ) continue;
							 
							 $DATA['bonus_config'][$sub.$type] = '';
						}
						  
						$bonus_list[] = $this->LANG->get($sub.$type.'_short').' '.$DATA['bonus_config'][$sub.$type].' '.$units[$sub];
						  
						unset($DATA[$sub.$type]);
					}
				}
				
				$DATA['salary_globals']['bonus_list'] = $bonus_list; unset($bonus_list);
			}

			return $DATA;
		}
	}

?>
