<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag operating suplie delete
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class SUPLIEDELETE	{

		function __construct()	{

			global $__SQL;
			
			$this->SQL		=	&$__SQL;

			$this->STOCKBASE	=	'ebagstock';
		}

		private function lock()		{

			$LOCK	=	'';

			foreach ($this->OPENED as $YEAR) $LOCK .=" , ebagdata$YEAR.operating_suplies_enter WRITE, 
								     ebagdata$YEAR.production_orders_header WRITE "; 

			$this->SQL->query("LOCK TABLES ebag.years WRITE, $this->STOCKBASE.operating_suplies WRITE".$LOCK);
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function read_open_years()	{

			$this->SQL->query("	SELECT `year` 
						FROM ebag.years
						WHERE `closed` IS NULL	");

			if ($this->SQL->num_rows())	{
			
				$this->OPENED = array();

				while ($RESULT = $this->SQL->RESULT->fetch_row()) $this->OPENED[] = $RESULT[0];
			}
		}

		public function delete($ID)	{

			$ID	=	$this->SQL->escape($ID);

			$this->read_open_years();

			if (! count($this->OPENED)) return 'noopenyearsfound';

			# check the suplie exists or deleted is

			$this->SQL->query("	SELECT `code` 
						FROM $this->STOCKBASE.operating_suplies 
						WHERE `personID`='$ID' LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->unlock();

				return TRUE;
			}

			$RESULT	=	$this->SQL->RESULT->fetch_row();

			$code	=	$this->SQL->nr_escape($RESULT[0]);

			foreach ($this->OPENED as $YEAR)		{
			
				# check the suplie not have enter in opened years

				$this->SQL->query("	SELECT `personID` 
							FROM ebagdata$YEAR.operating_suplies_enter
							WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");

				if ($this->SQL->num_rows())	{

					$errtxt = "ordered_or_entered->year->$YEAR";

					break;
				}
				
				# check production for open years
				
				$this->SQL->query("	SELECT `personID`
							FROM ebagdata$YEAR.production_orders_header
							WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");
							
				if ($this->SQL->num_rows())	{

					$errtxt = "item_in_production->year->$YEAR";

					break;
				}
			}

			if (isset($errtxt))	{

				$this->unlock();

				return $errtxt;
			}
		
			# delete

			$this->SQL->query("	UPDATE $this->STOCKBASE.operating_suplies 
						SET `deleted`=NULL 
						WHERE `personID`='$ID' LIMIT 1	");

			$this->unlock();

			return TRUE;
		}
	}

?>

