<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * returns eBag requested items bonus value for defined parameters
	 */
	 
	if (isset($_POST['call']))	{
	
		if ($_POST['call'] == 'stock_id') unset($_POST['code']);
		
		if ($_POST['call'] == 'code') unset($_POST['stock_id']);
	}
	
	# translate
	
	foreach(array('employee_id'=>'employeeID', 'stock_id'=>'stockID', 'phase_id'=>'phaseID') as $key=>$val)	{
	
		if (isset($_POST[$key])) {$_POST[$val]=$_POST[$key]; unset($_POST[$key]);}
	}
	
	if ($_POST['phaseID'] == 'none') unset($_POST['phase']);
	
	# Turn off magic quotes runtime

	if (get_magic_quotes_runtime())	set_magic_quotes_runtime(false);
	
	$REQ = array();

	foreach (array('employeeID', 'setting_type', 'bonus_type', 'phaseID', 'stockID', 'code') as $getVal)	{
	
		$REQ[$getVal] = '';
	
		if (isset($_POST[$getVal])) $REQ[$getVal] = $_POST[$getVal];
		
		# If magic quotes is enabled strip slashes from code
		
		if (get_magic_quotes_gpc()) $REQ[$getVal] = stripslashes($REQ[$getVal]);
	}
	
	if ((! $REQ['employeeID'])  or (! $REQ['setting_type']) or (! $REQ['bonus_type'])) exit;
	
	if ($REQ['setting_type'] == 1)	{
	  
		if (! $REQ['phaseID']) exit;
	
		$REQ['stockID'] = $REQ['code'] = FALSE;
	
	}	else	 {
	
		if ((! $REQ['stockID']) && (! $REQ['code'])) exit('1');
	}

	# read configuration

	include('../classes/INIload.class.php');

	$__CONF	= new INI_load('../conf/eBag.ini');
	
	# Sets session handler (important to refresh the session)

	include('../classes/Sessionhandler.class.php');

	$__SESS	=	new MysqlSession();
	$__SESS	->	set_session_handler();
	
	register_shutdown_function('session_write_close');

	session_start();
	
	if (isset($_SESSION['permission'])) {$_SESSION['permission'] = $_SESSION['permission'];} else {exit;}

	# create connection
	
	$mysqli = new mysqli($__CONF->get('connection', 'host'), $__CONF->get('connection', 'user'), $__CONF->get('connection', 'password'));
	
	if ($mysqli->connect_error) exit;
	
	$mysqli->set_charset("utf8");

	$mysqli->query("SET NAMES 'utf8' COLLATE 'utf8_bin'");
	
	# read from base
	
	$bonus_types = array(	1=>'percent_phases',
				2=>'fix_phases'	);
	
	if (isset($_SESSION['year_is_closed'])) {$stockbase = 'ebagdata'.$_SESSION['year'];} else {$stockbase = 'ebagstock';}
	
	$WHERE_STOCK_ = $WHERE_BONUSES_ = '';
	
	foreach (array('employeeID', 'setting_type', 'phaseID', 'stockID', 'code') as $key)	{
	
		if ($REQ[$key])	{
		
			$REQ[$key] = $mysqli->real_escape_string(htmlspecialchars($REQ[$key], $__CONF->get('specialchars', 'flag'), 'UTF-8', FALSE));
			
			$WHERE_BONUSES_ .= " AND `$key`='{$REQ[$key]}' "; 
			
			if ($key == 'stockID') 	$WHERE_STOCK_ .= " AND `personID`='{$REQ[$key]}' ";
			
			if ($key == 'code') $WHERE_STOCK_ .= " AND `code`='{$REQ[$key]}' ";
		}
	}
	
	$phaseID = $personID = $code = $name = $value = '';
	
	if ($REQ['setting_type'] == 2)	{
	
		$RESULT = $mysqli->query("	SELECT  `personID`, `articalname` as `name`, `code`, `origin`
						FROM     $stockbase.finished_goods_stock
						WHERE	`deleted` IS NOT NULL $WHERE_STOCK_ LIMIT 1");

		# Note: exit code 1 means not exists
		
		if (! $RESULT->num_rows) exit('1');

		extract($RESULT->fetch_assoc());
		
		if ($origin != 1) exit('2');
		
		unset($origin);
	}
	
	if ($REQ['phaseID'])	{
	
		$phaseID = $REQ['phaseID'];
	
		$RESULT = $mysqli->query("	SELECT  `{$bonus_types[$REQ['bonus_type']]}` as `value`
						FROM     ebagdata{$_SESSION['year']}.employees_phases_bonuses
						WHERE	`deleted` IS NOT NULL $WHERE_BONUSES_ LIMIT 1 ");
						
		if ($RESULT->num_rows) extract($RESULT->fetch_assoc());						
	}

	header('Expires: Sun, 10 Jan 2010 12:00:00 GMT'); 
	header('Last-Modified: '.@gmdate( 'D, d M Y H:i:s').' GMT');
	header('Cache-Control: no-cache, no-store, must-revalidate');
	header('Pragma: no-cache');
	header('Content-Type: text/xml');

	echo  '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>'."\n"
	     ."<response>\r\n<data>\r\n<phase_id>$phaseID</phase_id>\r\n<stock_id>$personID</stock_id>\r\n<code>$code</code>\r\n<item_name>$name</item_name>\r\n<bonus_value>$value</bonus_value>\r\n</data>\r\n</response>";


?>
