<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * returns eBag requested name by code and unit
	 * or nothing if the name is not defined
	 */

	if ((! isset($_GET['code'])) or (! isset($_GET['table']))) exit;
	 
	# Turn off magic quotes runtime

	if (get_magic_quotes_runtime())	set_magic_quotes_runtime(false);

	# If magic quotes is enabled strip slashes from code

	if (get_magic_quotes_gpc()) $_GET['code'] = stripslashes($_GET['code']);

	$code	=	$_GET['code'];
	$TABLE	=	$_GET['table'];

	$NAMES	=	array(	'services'		=>	'servicename',
				'feedstock'		=>	'feedstockname',
				'stock'			=>	'articalname',
				'operating_suplies'	=>	'supliename',
				'services_stock'	=>	'',	
				'feedstock_stock'	=>	'');

	$NAME 	=	$NAMES[$TABLE];

	# read configuration

	include('../classes/INIload.class.php');

	$__CONF	= new INI_load('../conf/eBag.ini');
	
	# create connection
	
	$mysqli = new mysqli($__CONF->get('connection', 'host'), $__CONF->get('connection', 'user'), $__CONF->get('connection', 'password'));
	
	if ($mysqli->connect_error) exit;
	
	$mysqli->set_charset("utf8");

	$mysqli->query("SET NAMES 'utf8' COLLATE 'utf8_bin'");
	
	# quick check for session
	
	if (! ($SessionName = ini_get('session.name'))) $SessionName = 'PHPSESSID';
	
	$time = time();
	
	$result = $mysqli->query("	SELECT `expiration` 
					FROM ebagtemp.sessions 
					WHERE `SID`='{$_COOKIE[$SessionName]}' AND expiration > $time LIMIT 1	");
	if (! $result->num_rows) exit;
	
	unset($time, $SessionName);
	
	# read from base

	$code	=	$mysqli->real_escape_string(htmlspecialchars($code, $__CONF->get('specialchars', 'flag'), 'UTF-8', FALSE));
	
	if ($TABLE == 'services_stock')		{

		# note: type a => artical, s => service, needs by js

		$RESULT = $mysqli->query("(SELECT  `articalname` as `name`, `unit`, `price`, `tax`, 'a' AS `type` FROM ebagstock.finished_goods_stock WHERE `deleted` IS NOT NULL AND `code`='$code' LIMIT 1) 
			   		  UNION ALL 
			 	 	  (SELECT `servicename` as `name`, `unit`, `price`, `tax`, 's' AS `type` FROM ebagstock.services WHERE `deleted` IS NOT NULL AND `code`='$code' LIMIT 1 )");

	}  elseif ($TABLE == 'feedstock_stock')  {
	
		# note: type a => artical, f => service, needs by js

		$RESULT = $mysqli->query("(SELECT `feedstockname` as `name`, `unit`, `purchase_price` AS `price`, '0' AS `tax`, 'f' AS `type` FROM ebagstock.feedstock WHERE `deleted` IS NOT NULL AND `code`='$code' LIMIT 1 ) 
			   		  UNION ALL 
			 	 	  (SELECT `articalname` as `name`, `unit`, `price`, `tax`, 'a' AS `type` FROM ebagstock.finished_goods_stock WHERE `deleted` IS NOT NULL AND `code`='$code' LIMIT 1)");

	
	}  else  {
	
		if (($TABLE == 'feedstock') or ($TABLE == 'operating_suplies')) {$PRICE = 'purchase_price'; $TAX = "'0' as `tax`";} else {$PRICE = 'price'; $TAX = '`tax`';}

		if ($TABLE == 'stock') $TABLE = 'finished_goods_stock';

		# note: type 0 is undefined (for tax and type), needs by js only

		$RESULT = $mysqli->query("SELECT `$NAME`, `unit`, `$PRICE`, $TAX, '0' AS `type` FROM ebagstock.$TABLE WHERE `code`='$code' AND `deleted` IS NOT NULL LIMIT 1");
	}

	if (! $RESULT->num_rows) exit;

	$R_ARRAY = $RESULT->fetch_row();

	header('Expires: Sun, 10 Jan 2010 12:00:00 GMT'); 
	header('Last-Modified: '.@gmdate( 'D, d M Y H:i:s').' GMT');
	header('Cache-Control: no-cache, no-store, must-revalidate');
	header('Pragma: no-cache');
	header('Content-Type: text/xml');

	echo  '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>'."\n"
	     ."<response>\r\n<data>\r\n<name>".$R_ARRAY[0]."</name>\r\n<unit>".$R_ARRAY[1]."</unit>\r\n<price>".$R_ARRAY[2]."</price>\r\n<tax>".$R_ARRAY[3]."</tax>\r\n<type>".$R_ARRAY[4]."</type>\r\n</data>\r\n</response>";


?>
