<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * write quantity change into defined inventory table
	 */
	 
	if ((! isset($_POST['code'])) or (! isset($_POST['table'])) or (! isset($_POST['invtable'])) or (! isset($_POST['quantity']))) exit;

	# Turn off magic quotes runtime

	if (get_magic_quotes_runtime())	set_magic_quotes_runtime(false);

	# If magic quotes is enabled strip slashes 

	if (get_magic_quotes_gpc()) {

		foreach ($_POST as $key=>$val) $_POST[$key] = stripslashes($val);
	}

	# read configuration
	
	include('../classes/INIload.class.php');

	$__CONF	= new INI_load('../conf/eBag.ini');

	# read units
	
	include('../classes/UNITloader.class.php');
	
	# Special modified SQL class 
	# Only methods needed by UNITloader
	# if the APC is turned off
	
	class SQL	{
	
		function __construct()	{
		
			global $__CONF;
			
			$this->mysqli = new mysqli($__CONF->get('connection', 'host'), $__CONF->get('connection', 'user'), $__CONF->get('connection', 'password'));

			if ($this->mysqli->connect_error) exit('Can\'t connect to mysql server ('.$this->mysqli->connect_errno. ') '. $this->mysqli->connect_error.' !');
			
			$this->mysqli->set_charset("utf8");

			$this->mysqli->query("	SET 
						NAMES 'utf8' 
						COLLATE 'utf8_bin'	");
		}
	
		public function query($query)	{

			$this->RESULT	=	$this->mysqli->query($query);
		}
		
		public function num_rows()	{

			return $this->RESULT->num_rows;
		}
		
		public function free()	{

			$this->RESULT->close();
		}
	}

	# important to refresh the session because in this case the main will not

	# Sets session handler

	include('../classes/Sessionhandler.class.php');

	$__SESS	=	new MysqlSession();
	$__SESS	->	set_session_handler();
	
	register_shutdown_function('session_write_close');

	session_start();
	
	# Check for session protect from unathorized data write
	
	if (isset($_SESSION['permission']))	{
	
		# refresh
	
		$_SESSION['permission'] = $_SESSION['permission'];
		
	}	else	  {
	
		exit;
	}

	$code	=	$_POST['code'];

	if ($_POST['table'] == 'stock')		{

		$TABLE	= 'finished_goods_stock';
	
	}	else	 {

		$TABLE = $_POST['table'];
	}

	$NAMES	=	array(	'feedstock'		=>	'feedstockname',
				'finished_goods_stock'	=>	'articalname',
				'operating_suplies'	=>	'supliename'	);

	$NAME 	=	$NAMES[$TABLE];

	$INVTABLE	=	$_POST['invtable'];

	$quantity	=	$_POST['quantity'];

	if ((! is_numeric($quantity)) or ($quantity <= 0)) exit;

	# create connection
	
	$__SQL = new SQL;
	
	$code	=	$__SQL->mysqli->real_escape_string(htmlspecialchars($code, $__CONF->get('specialchars', 'flag'), 'UTF-8', FALSE));

	$__SQL->query("	SELECT  `personID`, `$NAME` as `itemname`, `unit`
			FROM ebagstock.$TABLE 
			WHERE `deleted` IS NOT NULL AND `code`='$code' LIMIT 1	"); 

	if (! $__SQL->num_rows()) exit;

	extract($__SQL->RESULT->fetch_assoc());

	$UNITS	= new UNITloader($__CONF->get('cache', 'use_apc_cache'));

	if ($UNITS->is_int_unit($unit))		{

		if ($quantity-(integer)$quantity) exit;
	}
	
	unset($UNITS);

	$itemname	=	$__SQL->mysqli->real_escape_string($itemname);
	$unit		=	$__SQL->mysqli->real_escape_string($unit);

	$__SQL->query("	INSERT INTO ebagtemp.$INVTABLE
			VALUES
			('$personID', '$quantity')	");

	if ($__SQL->RESULT === FALSE) exit;

	$code		=	stripslashes($code);
	$itemname	=	stripslashes($itemname);
	$unit		=	stripslashes($unit);
	$quantity	=	number_format($quantity, 2, '.', '');

	echo <<<"EOT"
		<div class="columnames">
		<span class="spancolumns-code">$code</span>
		<span class="spancolumns-name-long">$itemname</span>
		<span class="spancolumns-quantity-long">$quantity</span>
		<span class="spancolumns-unit">$unit</span>
		</div>
EOT;


?>
